package com.hzya.frame.mdm.service.impl;

import cn.dev33.satoken.stp.StpUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.mdm.entity.DbFiledsDto;
import com.hzya.frame.mdm.entity.MdmDataDto;
import com.hzya.frame.mdm.entity.MdmDataFiledDto;
import com.hzya.frame.mdm.entity.MdmDbFiledVo;
import com.hzya.frame.mdm.entity.MdmDbVo;
import com.hzya.frame.mdm.entity.MdmDetailViewVo;
import com.hzya.frame.mdm.entity.MdmDistributeDto;
import com.hzya.frame.mdm.entity.MdmDto;
import com.hzya.frame.mdm.entity.MdmModuleViewDto;
import com.hzya.frame.mdm.entity.MdmModuleViewVo;
import com.hzya.frame.mdm.entity.MdmQuery;
import com.hzya.frame.mdm.entity.MdmSourceDto;
import com.hzya.frame.mdm.entity.MdmViewFiledVo;
import com.hzya.frame.mdm.entity.MdmViewVo;
import com.hzya.frame.mdm.mdmModule.dao.IMdmModuleDao;
import com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity;
import com.hzya.frame.mdm.mdmModuleDb.dao.IMdmModuleDbDao;
import com.hzya.frame.mdm.mdmModuleDb.entity.MdmModuleDbEntity;
import com.hzya.frame.mdm.mdmModuleDbFileds.dao.IMdmModuleDbFiledsDao;
import com.hzya.frame.mdm.mdmModuleDbFileds.entity.MdmModuleDbFiledsEntity;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.dao.IMdmModuleDbFiledsRuleDao;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity;
import com.hzya.frame.mdm.mdmModuleDistribute.dao.IMdmModuleDistributeDao;
import com.hzya.frame.mdm.mdmModuleDistribute.entity.MdmModuleDistributeEntity;
import com.hzya.frame.mdm.mdmModuleDistributeDetail.dao.IMdmModuleDistributeDetailDao;
import com.hzya.frame.mdm.mdmModuleOptionLog.dao.IMdmModuleOptionLogDao;
import com.hzya.frame.mdm.mdmModuleOptionLog.entity.MdmModuleOptionLogEntity;
import com.hzya.frame.mdm.mdmModuleSendLog.dao.IMdmModuleSendLogDao;
import com.hzya.frame.mdm.mdmModuleSendLog.entity.MdmModuleSendLogEntity;
import com.hzya.frame.mdm.mdmModuleSource.entity.MdmModuleSourceEntity;
import com.hzya.frame.mdm.mdmModuleView.dao.IMdmModuleViewDao;
import com.hzya.frame.mdm.mdmModuleView.entity.MdmModuleViewEntity;
import com.hzya.frame.mdm.mdmModuleViewButton.dao.IMdmModuleViewButtonDao;
import com.hzya.frame.mdm.mdmModuleViewButton.entity.MdmModuleViewButtonEntity;
import com.hzya.frame.mdm.mdmModuleViewDetail.dao.IMdmModuleViewDetailDao;
import com.hzya.frame.mdm.mdmModuleViewDetail.entity.MdmModuleViewDetailEntity;
import com.hzya.frame.mdm.mdmTableCodeRule.entity.MdmTableCodeRuleEntity;
import com.hzya.frame.mdm.service.IMdmService;

import com.hzya.frame.mdm.service.IMdmServiceCache;
import com.hzya.frame.sys.entity.FormmainDeleteDto;
import com.hzya.frame.sysnew.buttonConfig.dao.ISysButtonConfigDao;
import com.hzya.frame.sysnew.buttonConfig.entity.SysButtonConfigEntity;
import com.hzya.frame.sysnew.menuConfig.dao.ISysMenuConfigDao;
import com.hzya.frame.sysnew.menuConfig.entity.SysMenuConfigEntity;
import com.hzya.frame.sysnew.popedomOperate.dao.ISysPopedomOperateDao;
import com.hzya.frame.sysnew.popedomOperate.entity.SysPopedomOperateEntity;
import com.hzya.frame.sysnew.user.entity.SysUserEntity;
import com.hzya.frame.sysnew.userCompany.entity.SysUserCompanyEntity;
import com.hzya.frame.sysnew.userRoles.entity.SysUserRolesEntity;
import com.hzya.frame.uuid.UUIDUtils;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.checkerframework.checker.units.qual.A;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 主数据服务实现类
 */
@Service(value = "mdmService")
public class MdmServiceImpl implements IMdmService {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Resource
    private IMdmModuleDao mdmModuleDao;
    @Resource
    private IMdmModuleSendLogDao mdmModuleSendLogDao;
    @Resource
    private IMdmModuleOptionLogDao mdmModuleOptionLogDao;
    @Resource
    private IMdmServiceCache mdmServiceCache;
    @Resource
    private ISysMenuConfigDao sysMenuConfigDao;
    @Resource
    private ISysButtonConfigDao sysButtonConfigDao;
    @Resource
    private ISysPopedomOperateDao sysPopedomOperateDao;
    @Resource
    private IMdmModuleDbDao mdmModuleDbDao;
    @Resource
    private IMdmModuleDbFiledsDao mdmModuleDbFiledsDao;
    @Resource
    private IMdmModuleDbFiledsRuleDao mdmModuleDbFiledsRuleDao;
    @Resource
    private IMdmModuleDistributeDao mdmModuleDistributeDao;
    @Resource
    private IMdmModuleDistributeDetailDao mdmModuleDistributeDetailDao;
    @Resource
    private IMdmModuleViewDao mdmModuleViewDao;
    @Resource
    private IMdmModuleViewButtonDao mdmModuleViewButtonDao;
    @Resource
    private IMdmModuleViewDetailDao mdmModuleViewDetailDao;

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据列表查询接口分页
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmPage(JSONObject object) {
        MdmModuleEntity entity = getData("jsonStr", object, MdmModuleEntity.class);
        //判断分页
        if (entity == null || entity.getPageNum() == null || entity.getPageSize() == null) {
            return BaseResult.getFailureMessageEntity("分页查询参数不存在");
        }
        PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
        List<MdmModuleEntity> mdmVos = mdmModuleDao.queryMdm(entity);
        PageInfo pageInfo = new PageInfo(mdmVos);
        return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据列表查询接口列表
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmList(JSONObject object) {
        MdmModuleEntity entity = getData("jsonStr", object, MdmModuleEntity.class);
        List<MdmModuleEntity> mdmVos = mdmModuleDao.queryMdm(entity);
        return BaseResult.getSuccessMessageEntity("查询数据成功", mdmVos);
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据新增
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity addMdm(JSONObject object) {
        MdmModuleEntity entity = getData("jsonStr", object, MdmModuleEntity.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmName() == null || "".equals(entity.getMdmName())) {
            return BaseResult.getFailureMessageEntity("请先输入主数据名称");
        }
        if (entity.getMdmType() == null || "".equals(entity.getMdmType())) {
            return BaseResult.getFailureMessageEntity("请先选择主数据类型");
        }
        //新增
        entity.setCreate();
        mdmModuleDao.save(entity);
        return BaseResult.getSuccessMessageEntity("保存数据成功", entity);
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据基本信息获取
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmModule(JSONObject object) {
        MdmModuleEntity entity = getData("jsonStr", object, MdmModuleEntity.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //使用缓存
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        return BaseResult.getSuccessMessageEntity("查询数据成功", mdmModuleEntity);
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据基本信息保存
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity doSaveMdmModule(JSONObject object) {
        MdmModuleEntity entity = getData("jsonStr", object, MdmModuleEntity.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmName() == null || "".equals(entity.getMdmName())) {
            return BaseResult.getFailureMessageEntity("请先输入主数据名称");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null ){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        entity.setId(mdmModuleEntity.getId());
        //修改
        entity.setUpdate();
        mdmServiceCache.updateMdmModuleEntity(entity);
        return BaseResult.getSuccessMessageEntity("修改主数据成功", entity);
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置查询数据源
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmModuleDb(JSONObject object) {
        MdmModuleEntity entity = getData("jsonStr", object, MdmModuleEntity.class);
        //判断分页
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmDbVo mdmDbVo = new MdmDbVo();
        //获取主数据
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        //查询设置的规则表
        MdmTableCodeRuleEntity mdmTableCodeRuleEntity = new MdmTableCodeRuleEntity();
        mdmTableCodeRuleEntity.setSts("Y");
        mdmTableCodeRuleEntity.setMdmId(mdmModuleEntity.getId());
        List<MdmTableCodeRuleEntity> mdmTableCodeRuleEntityList = mdmServiceCache.queryMdmTableCodeRuleEntity(mdmTableCodeRuleEntity);
        mdmDbVo.setMdmTableCodeRuleEntityList(mdmTableCodeRuleEntityList);
        //查询数据源表
        MdmModuleDbEntity queryDb = new MdmModuleDbEntity();
        queryDb.setMdmId(mdmModuleEntity.getId());
        queryDb.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(queryDb);
        //数据源字段
        MdmModuleDbFiledsEntity queryDbFiled = new MdmModuleDbFiledsEntity();
        queryDbFiled.setMdmId(mdmModuleEntity.getId());
        queryDbFiled.setSts("Y");
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmServiceCache.queryMdmModuleDbFileds(queryDbFiled);
        //数据源字段规则
        MdmModuleDbFiledsRuleEntity queryDbFiledRule = new MdmModuleDbFiledsRuleEntity();
        queryDbFiledRule.setMdmId(mdmModuleEntity.getId());
        queryDbFiledRule.setSts("Y");
        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList = mdmServiceCache.queryMdmModuleDbFiledsRule(queryDbFiledRule);
        //组装数据
        setMdmDb(mdmDbVo, mdmModuleDbEntityList, mdmModuleDbFiledsEntityList, mdmModuleDbFiledsRuleEntityList);
        return BaseResult.getSuccessMessageEntity("查询数据成功", mdmDbVo);
    }
    /**
     * @param mdmDbVo                         返回对象
     * @param mdmModuleDbEntityList           数据表
     * @param mdmModuleDbFiledsEntityList     字段
     * @param mdmModuleDbFiledsRuleEntityList 字段属性
     * @return void
     * @Author lvleigang
     * @Description 组装返回数据
     * @Date 4:51 下午 2023/10/18
     **/
    private void setMdmDb(MdmDbVo mdmDbVo, List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList, List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList) {
        //主数据主表
        MdmModuleDbEntity mainMdmModuleDb = new MdmModuleDbEntity();
        //主数据子表
        List<MdmModuleDbEntity> sublistMdmModuleDb = new ArrayList<>();
        //主数据主表字段
        List<MdmModuleDbFiledsEntity> mainMdmModuleDbFileds = new ArrayList<>();


        if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    //1、主表 2、明细
                    mainMdmModuleDb = mdmModuleDbEntityList.get(i);
                    //循环字段表
                    if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
                        for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                            if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
                                mainMdmModuleDbFileds.add(mdmModuleDbFiledsEntityList.get(i1));
                                List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRules = new ArrayList<>();
                                //循环字段属性
                                if (mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0) {
                                    for (int i2 = 0; i2 < mdmModuleDbFiledsRuleEntityList.size(); i2++) {
                                        if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getDbId())
                                                && mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getFiledId())) {
                                            mdmModuleDbFiledsRules.add(mdmModuleDbFiledsRuleEntityList.get(i2));
                                        }
                                    }
                                }
                                mdmModuleDbFiledsEntityList.get(i1).setMdmModuleDbFiledsRules(mdmModuleDbFiledsRules);
                            }
                        }
                    }
                } else if ("2".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    //2、明细
                    sublistMdmModuleDb.add(mdmModuleDbEntityList.get(i));
                    //循环字段表
                    if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
                        List<MdmModuleDbFiledsEntity> sublistMdmModuleDbFileds = new ArrayList<>();
                        for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                            if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
                                sublistMdmModuleDbFileds.add(mdmModuleDbFiledsEntityList.get(i1));
                                List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRules = new ArrayList<>();
                                //循环字段属性
                                if (mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0) {
                                    for (int i2 = 0; i2 < mdmModuleDbFiledsRuleEntityList.size(); i2++) {
                                        if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getDbId())
                                                && mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getFiledId())) {
                                            mdmModuleDbFiledsRules.add(mdmModuleDbFiledsRuleEntityList.get(i2));
                                        }
                                    }
                                }
                                mdmModuleDbFiledsEntityList.get(i1).setMdmModuleDbFiledsRules(mdmModuleDbFiledsRules);
                            }
                        }
                        mdmModuleDbEntityList.get(i).setSublistMdmModuleDbFileds(sublistMdmModuleDbFileds);
                    }
                }
            }
        }
        mainMdmModuleDb.setSublistMdmModuleDbFileds(mainMdmModuleDbFileds);
        mdmDbVo.setMainMdmModuleDb(mainMdmModuleDb);
        mdmDbVo.setSublistMdmModuleDb(sublistMdmModuleDb);
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置保存数据源
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity saveMdmModuleDb(JSONObject object) {
        //判断新增还是修改，保存数据生成表结构
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //单据规则校验
        if(entity.getMdmTableCodeRuleEntityList() == null || entity.getMdmTableCodeRuleEntityList().size() == 0){
            return BaseResult.getFailureMessageEntity("请先设置单据规则");
        }
        //主表校验
        if (entity.getMainMdmModuleDb() == null || entity.getMainMdmModuleDb().getDbName() == null || "".equals(entity.getMainMdmModuleDb().getDbName())) {
            return BaseResult.getFailureMessageEntity("请先输入主表名称");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        //主数据主表
        MdmModuleDbEntity mainMdmModuleDb = entity.getMainMdmModuleDb();
        //主数据主表字段
        List<MdmModuleDbFiledsEntity> mainMdmModuleDbFileds = mainMdmModuleDb.getSublistMdmModuleDbFileds();
        //主数据子表
        List<MdmModuleDbEntity> sublistMdmModuleDb = entity.getSublistMdmModuleDb();
        //单据规则
        List<MdmTableCodeRuleEntity> mdmTableCodeRuleEntities = entity.getMdmTableCodeRuleEntityList();
        // 需要校验表是否存在
        if (checkTable(mainMdmModuleDb.getDbName())) {
            return BaseResult.getFailureMessageEntity("主表表名已经存在");
        }
        if(mainMdmModuleDbFileds == null || mainMdmModuleDbFileds.size() == 0){
            return BaseResult.getFailureMessageEntity("请先设置主表字段");
        }
        //判断明细表
        if (sublistMdmModuleDb != null && sublistMdmModuleDb.size() > 0) {
            for (int i = 0; i < sublistMdmModuleDb.size(); i++) {
                // 需要校验表是否存在
                if (checkTable(sublistMdmModuleDb.get(i).getDbName())) {
                    return BaseResult.getFailureMessageEntity("子表" + sublistMdmModuleDb.get(i).getDbName() + "已经存在");
                }
                if (sublistMdmModuleDb.get(i).getSublistMdmModuleDbFileds() == null && sublistMdmModuleDb.get(i).getSublistMdmModuleDbFileds().size() == 0) {
                    return BaseResult.getFailureMessageEntity("请先设置子表" + sublistMdmModuleDb.get(i).getDbName() + "的字段");
                }

            }
        }
        //处理数据
        //分别设置成 数据源 数据源字段 数据源规则表 设置是否新增修改  没有id新增，有ID修改
        List<MdmModuleDbEntity> mdmModuleDbEntities = new ArrayList<>();
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntities = new ArrayList<>();
        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntities = new ArrayList<>();

        //主表
        if(mainMdmModuleDb.getId() != null && !"".equals(mainMdmModuleDb.getId())){
            //修改
            mainMdmModuleDb.setDataType("2");
            mainMdmModuleDb.setUpdate();
        }else {
            //新增
            mainMdmModuleDb.setDataType("1");
            mainMdmModuleDb.setMdmId(mdmModuleEntity.getId());
            mainMdmModuleDb.setCreate();
        }
        mainMdmModuleDb.setDbType("1");
        mdmModuleDbEntities.add(mainMdmModuleDb);
        for (int i = 0; i < mdmTableCodeRuleEntities.size(); i++) {
            mdmTableCodeRuleEntities.get(i).setMdmId(mdmModuleEntity.getId());
            mdmTableCodeRuleEntities.get(i).setDbId(mainMdmModuleDb.getId());
            mdmTableCodeRuleEntities.get(i).setCreate();
        }
        for (int i = 0; i < mainMdmModuleDbFileds.size(); i++) {
            if(mainMdmModuleDbFileds.get(i).getId() != null && !"".equals(mainMdmModuleDbFileds.get(i).getId())){
                //修改
                mainMdmModuleDbFileds.get(i).setDataType("2");
                mainMdmModuleDbFileds.get(i).setUpdate();
            }else {
                //新增
                mainMdmModuleDbFileds.get(i).setDataType("1");
                mainMdmModuleDbFileds.get(i).setCreate();
            }
            mainMdmModuleDbFileds.get(i).setMdmId(mdmModuleEntity.getId());
            mainMdmModuleDbFileds.get(i).setDbId(mainMdmModuleDb.getId());
            mainMdmModuleDbFileds.get(i).setAddType("1");
            mainMdmModuleDbFileds.get(i).setUpdateType("1");
            mainMdmModuleDbFileds.get(i).setShowType("1");
            mainMdmModuleDbFileds.get(i).setQueryType("1");
            mainMdmModuleDbFileds.get(i).setListType("1");
            mainMdmModuleDbFileds.get(i).setViewType("1");
            if(mainMdmModuleDbFileds.get(i).getMdmModuleDbFiledsRules() != null && mainMdmModuleDbFileds.get(i).getMdmModuleDbFiledsRules().size() > 0){
                for (int i1 = 0; i1 < mainMdmModuleDbFileds.get(i).getMdmModuleDbFiledsRules().size(); i1++) {
                    MdmModuleDbFiledsRuleEntity mdmModuleDbFiledsRuleEntity = mainMdmModuleDbFileds.get(i).getMdmModuleDbFiledsRules().get(i1);
                    if(mdmModuleDbFiledsRuleEntity.getId() != null && !"".equals(mdmModuleDbFiledsRuleEntity.getId())){
                        //修改
                        mdmModuleDbFiledsRuleEntity.setDataType("2");
                        mdmModuleDbFiledsRuleEntity.setUpdate();
                    }else {
                        //新增
                        mdmModuleDbFiledsRuleEntity.setDataType("1");
                        mdmModuleDbFiledsRuleEntity.setCreate();
                    }
                    mdmModuleDbFiledsRuleEntities.add(mdmModuleDbFiledsRuleEntity);
                }
            }
            mdmModuleDbFiledsEntities.add(mainMdmModuleDbFileds.get(i));
        }
        if("1".equals(mainMdmModuleDb.getDataType())){
            //新增 设置默认字段
            List<MdmModuleDbFiledsEntity> moduleDbFiledsEntities = getCreateMdm(mdmModuleEntity.getId(),mainMdmModuleDb.getId(),"1");
            mdmModuleDbFiledsEntities.addAll(moduleDbFiledsEntities);
        }
        //明细表
        if(sublistMdmModuleDb != null && sublistMdmModuleDb.size() > 0){
            for (int i = 0; i < sublistMdmModuleDb.size(); i++) {
                MdmModuleDbEntity mdmModuleDbEntity = sublistMdmModuleDb.get(i);
                if(mdmModuleDbEntity.getId() != null && !"".equals(mdmModuleDbEntity.getId())){
                    //修改
                    mdmModuleDbEntity.setDataType("2");
                    mdmModuleDbEntity.setUpdate();
                }else {
                    //新增
                    mdmModuleDbEntity.setDataType("1");
                    mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
                    mdmModuleDbEntity.setCreate();
                }
                mainMdmModuleDb.setDbType("2");
                mdmModuleDbEntities.add(mdmModuleDbEntity);
                for (int a = 0; a < mdmModuleDbEntity.getSublistMdmModuleDbFileds().size(); a++) {
                    if(mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).getId() != null && !"".equals(mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).getId())){
                        //修改
                        mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setDataType("2");
                        mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setUpdate();
                    }else {
                        //新增
                        mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setDataType("1");
                        mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setCreate();
                    }
                    mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setMdmId(mdmModuleEntity.getId());
                    mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setDbId(mainMdmModuleDb.getId());
                    mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setAddType("1");
                    mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setUpdateType("1");
                    mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setShowType("1");
                    mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setQueryType("1");
                    mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setListType("1");
                    mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).setViewType("1");
                    if(mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).getMdmModuleDbFiledsRules() != null && mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a).getMdmModuleDbFiledsRules().size() > 0){
                        for (int i1 = 0; i1 < mainMdmModuleDbFileds.get(a).getMdmModuleDbFiledsRules().size(); i1++) {
                            MdmModuleDbFiledsRuleEntity mdmModuleDbFiledsRuleEntity = mainMdmModuleDbFileds.get(a).getMdmModuleDbFiledsRules().get(i1);
                            if(mdmModuleDbFiledsRuleEntity.getId() != null && !"".equals(mdmModuleDbFiledsRuleEntity.getId())){
                                //修改
                                mdmModuleDbFiledsRuleEntity.setDataType("2");
                                mdmModuleDbFiledsRuleEntity.setUpdate();
                            }else {
                                //新增
                                mdmModuleDbFiledsRuleEntity.setDataType("1");
                                mdmModuleDbFiledsRuleEntity.setCreate();
                            }
                            mdmModuleDbFiledsRuleEntities.add(mdmModuleDbFiledsRuleEntity);
                        }
                    }
                    mdmModuleDbFiledsEntities.add(mdmModuleDbEntity.getSublistMdmModuleDbFileds().get(a));
                }
                if("1".equals(mainMdmModuleDb.getDataType())){
                    //新增 设置默认字段
                    List<MdmModuleDbFiledsEntity> moduleDbFiledsEntities = getCreateMdm(mdmModuleEntity.getId(),mainMdmModuleDb.getId(),"2");
                    mdmModuleDbFiledsEntities.addAll(moduleDbFiledsEntities);
                }
            }
        }


        //新增日志表
        if("1".equals(mainMdmModuleDb.getDataType())){
            MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
            mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
            mdmModuleDbEntity.setDbName(mainMdmModuleDb.getDbName()+"_option_log");
            mdmModuleDbEntity.setDbType("3");
            mdmModuleDbEntity.setDataType("1");
            mdmModuleDbEntity.setCreate();
            mdmModuleDbEntities.add(mdmModuleDbEntity);
            //新增 设置日志表
            List<MdmModuleDbFiledsEntity> moduleDbFiledsEntities = getCreateMdm(mdmModuleEntity.getId(),mdmModuleDbEntity.getId(),"3");
            mdmModuleDbFiledsEntities.addAll(moduleDbFiledsEntities);

            MdmModuleDbEntity mdmModuleDbEntity1 = new MdmModuleDbEntity();
            mdmModuleDbEntity1.setMdmId(mdmModuleEntity.getId());
            mdmModuleDbEntity1.setDbName(mainMdmModuleDb.getDbName()+"_option_log");
            mdmModuleDbEntity1.setDbType("4");
            mdmModuleDbEntity1.setDataType("1");
            mdmModuleDbEntity1.setCreate();
            mdmModuleDbEntities.add(mdmModuleDbEntity1);
            //新增 设置日志表
            List<MdmModuleDbFiledsEntity> moduleDbFiledsEntities1 = getCreateMdm(mdmModuleEntity.getId(),mdmModuleDbEntity1.getId(),"4");
            mdmModuleDbFiledsEntities.addAll(moduleDbFiledsEntities1);
        }
        //保存单据规则
        mdmServiceCache.saveMdmTableCodeRule(mdmModuleEntity.getId(),mdmTableCodeRuleEntities);
        //保存db
        mdmServiceCache.saveMdmModuleDb(mdmModuleEntity.getId(),mdmModuleDbEntities);
        //保存字段
        mdmServiceCache.saveMdmModuleDbFileds(mdmModuleEntity.getId(),mdmModuleDbFiledsEntities);
        //保存规则
        mdmServiceCache.saveMdmModuleDbFiledsRule(mdmModuleEntity.getId(),mdmModuleDbFiledsRuleEntities);
        //创建或者修改表

        for (int i = 0; i < mdmModuleDbEntities.size(); i++) {
            Map<String, Object> maps = new HashMap<>();
            maps.put("tableName", mdmModuleDbEntities.get(i).getDbName());//表名
            maps.put("tableRemark", mdmModuleDbEntities.get(i).getRemark());//表备注
            List<DbFiledsDto> dbFiledsDtos = new ArrayList<>();
            for (int i1 = 0; i1 < mdmModuleDbFiledsEntities.size(); i1++) {
                if(mdmModuleDbEntities.get(i).getId().equals(mdmModuleDbFiledsEntities.get(i1).getDbId())){
                    dbFiledsDtos.add(new DbFiledsDto(mdmModuleDbFiledsEntities.get(i1).getDataType(), mdmModuleDbFiledsEntities.get(i1).getChName(), mdmModuleDbFiledsEntities.get(i1).getEnName(), mdmModuleDbFiledsEntities.get(i1).getFiledType(), mdmModuleDbFiledsEntities.get(i1).getFiledLength()));
                }
            }
            maps.put("databaseFields", dbFiledsDtos);//字段
            if("1".equals(mdmModuleDbEntities.get(i).getDataType())){
                mdmModuleDao.createTable(maps);
            }else {
                Map<String, String> tablename = new HashMap<>();
                tablename.put("tableName", mdmModuleDbEntities.get(i).getDbName());//表名
                tablename.put("tableRemark", mdmModuleDbEntities.get(i).getRemark());//表备注
                mdmModuleDao.alterTableName(tablename);
                mdmModuleDao.alterTable(maps);
            }
        }
        return BaseResult.getSuccessMessageEntity("保存数据源成功");
    }

    /**
     * @Author lvleigang
     * @Description  新建设置默认字段
     * @Date 2:06 下午 2024/6/3
     * @param mdmId
     * @param dbId
     * @param type
     * @return java.util.List<com.hzya.frame.mdm.mdmModuleDbFileds.entity.MdmModuleDbFiledsEntity>
     **/
    private List<MdmModuleDbFiledsEntity> getCreateMdm(String mdmId, String dbId, String type) {
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntities = new ArrayList<>();
        MdmModuleDbFiledsEntity id = new MdmModuleDbFiledsEntity();
        id.setMdmId(mdmId);
        id.setDbId(dbId);
        id.setChName("id");
        id.setEnName("id");
        id.setFiledType("3");
        id.setAddType("2");
        id.setUpdateType("2");
        id.setShowType("2");
        id.setQueryType("2");
        id.setListType("2");
        id.setViewType("2");
        id.setFiledLength("50");
        id.setDataType("1");
        mdmModuleDbFiledsEntities.add(id);

        if("1".equals(type)){
            MdmModuleDbFiledsEntity documentRule = new MdmModuleDbFiledsEntity();
            documentRule.setMdmId(mdmId);
            documentRule.setDbId(dbId);
            documentRule.setChName("document_rule");
            documentRule.setEnName("单据规则");
            documentRule.setFiledType("3");
            documentRule.setAddType("2");
            documentRule.setUpdateType("1");
            documentRule.setShowType("1");
            documentRule.setQueryType("1");
            documentRule.setListType("1");
            documentRule.setViewType("1");
            documentRule.setFiledLength("50");
            documentRule.setDataType("1");
            mdmModuleDbFiledsEntities.add(documentRule);
        }

        if("1".equals(type)){
            MdmModuleDbFiledsEntity document_rule_num = new MdmModuleDbFiledsEntity();
            document_rule_num.setMdmId(mdmId);
            document_rule_num.setDbId(dbId);
            document_rule_num.setChName("document_rule_num");
            document_rule_num.setEnName("单据规则流水号");
            document_rule_num.setFiledType("1");
            document_rule_num.setAddType("2");
            document_rule_num.setUpdateType("2");
            document_rule_num.setShowType("2");
            document_rule_num.setQueryType("2");
            document_rule_num.setListType("2");
            document_rule_num.setViewType("2");
            document_rule_num.setFiledLength("50");
            document_rule_num.setDataType("1");
            mdmModuleDbFiledsEntities.add(document_rule_num);
        }
        if("2".equals(type) || "3".equals(type) || "4".equals(type) ){
            MdmModuleDbFiledsEntity formmain_id = new MdmModuleDbFiledsEntity();
            formmain_id.setMdmId(mdmId);
            formmain_id.setDbId(dbId);
            formmain_id.setChName("formmain_id");
            formmain_id.setEnName("主表id");
            formmain_id.setFiledType("3");
            formmain_id.setAddType("2");
            formmain_id.setUpdateType("2");
            formmain_id.setShowType("2");
            formmain_id.setQueryType("2");
            formmain_id.setListType("2");
            formmain_id.setViewType("2");
            formmain_id.setFiledLength("50");
            formmain_id.setDataType("1");
            mdmModuleDbFiledsEntities.add(formmain_id);
        }
        //写入日志字段：操作人
        if("3".equals(type)){
            MdmModuleDbFiledsEntity source_name = new MdmModuleDbFiledsEntity();
            source_name.setMdmId(mdmId);
            source_name.setDbId(dbId);
            source_name.setChName("source_name");
            source_name.setEnName("来源名称");
            source_name.setFiledType("3");
            source_name.setAddType("2");
            source_name.setUpdateType("2");
            source_name.setShowType("2");
            source_name.setQueryType("2");
            source_name.setListType("2");
            source_name.setViewType("2");
            source_name.setFiledLength("50");
            source_name.setDataType("1");
            mdmModuleDbFiledsEntities.add(source_name);

            MdmModuleDbFiledsEntity code = new MdmModuleDbFiledsEntity();
            code.setMdmId(mdmId);
            code.setDbId(dbId);
            code.setChName("code");
            code.setEnName("编码");
            code.setFiledType("3");
            code.setAddType("2");
            code.setUpdateType("2");
            code.setShowType("2");
            code.setQueryType("2");
            code.setListType("2");
            code.setViewType("2");
            code.setFiledLength("50");
            code.setDataType("1");
            mdmModuleDbFiledsEntities.add(code);

            MdmModuleDbFiledsEntity source_data = new MdmModuleDbFiledsEntity();
            source_data.setMdmId(mdmId);
            source_data.setDbId(dbId);
            source_data.setChName("source_data");
            source_data.setEnName("源数据");
            source_data.setFiledType("3");
            source_data.setAddType("2");
            source_data.setUpdateType("2");
            source_data.setShowType("2");
            source_data.setQueryType("2");
            source_data.setListType("2");
            source_data.setViewType("2");
            source_data.setFiledLength("255");
            source_data.setDataType("1");
            mdmModuleDbFiledsEntities.add(source_data);

            MdmModuleDbFiledsEntity option_type = new MdmModuleDbFiledsEntity();
            option_type.setMdmId(mdmId);
            option_type.setDbId(dbId);
            option_type.setChName("option_type");
            option_type.setEnName("操作类型");
            option_type.setFiledType("3");
            option_type.setAddType("2");
            option_type.setUpdateType("2");
            option_type.setShowType("2");
            option_type.setQueryType("2");
            option_type.setListType("2");
            option_type.setViewType("2");
            option_type.setFiledLength("255");
            option_type.setDataType("1");
            mdmModuleDbFiledsEntities.add(option_type);

            MdmModuleDbFiledsEntity option_Name = new MdmModuleDbFiledsEntity();
            option_Name.setMdmId(mdmId);
            option_Name.setDbId(dbId);
            option_Name.setChName("option_name");
            option_Name.setEnName("操作人");
            option_Name.setFiledType("3");
            option_Name.setAddType("2");
            option_Name.setUpdateType("2");
            option_Name.setShowType("2");
            option_Name.setQueryType("2");
            option_Name.setListType("2");
            option_Name.setViewType("2");
            option_Name.setFiledLength("255");
            option_Name.setDataType("1");
            mdmModuleDbFiledsEntities.add(option_Name);
        }

        //目标应用、目标api、
        if("4".equals(type)){
            MdmModuleDbFiledsEntity target_app = new MdmModuleDbFiledsEntity();
            target_app.setMdmId(mdmId);
            target_app.setDbId(dbId);
            target_app.setChName("target_app");
            target_app.setEnName("目标应用");
            target_app.setFiledType("1");
            target_app.setAddType("2");
            target_app.setUpdateType("2");
            target_app.setShowType("2");
            target_app.setQueryType("2");
            target_app.setListType("2");
            target_app.setViewType("2");
            target_app.setFiledLength("50");
            target_app.setDataType("1");
            mdmModuleDbFiledsEntities.add(target_app);

            MdmModuleDbFiledsEntity target_api = new MdmModuleDbFiledsEntity();
            target_api.setMdmId(mdmId);
            target_api.setDbId(dbId);
            target_api.setChName("target_api");
            target_api.setEnName("目标api");
            target_api.setFiledType("1");
            target_api.setAddType("2");
            target_api.setUpdateType("2");
            target_api.setShowType("2");
            target_api.setQueryType("2");
            target_api.setListType("2");
            target_api.setViewType("2");
            target_api.setFiledLength("50");
            target_api.setDataType("1");
            mdmModuleDbFiledsEntities.add(target_api);

            MdmModuleDbFiledsEntity source_data = new MdmModuleDbFiledsEntity();
            source_data.setMdmId(mdmId);
            source_data.setDbId(dbId);
            source_data.setChName("source_data");
            source_data.setEnName("源数据");
            source_data.setFiledType("3");
            source_data.setAddType("2");
            source_data.setUpdateType("2");
            source_data.setShowType("2");
            source_data.setQueryType("2");
            source_data.setListType("2");
            source_data.setViewType("2");
            source_data.setFiledLength("255");
            source_data.setDataType("1");
            mdmModuleDbFiledsEntities.add(source_data);

            MdmModuleDbFiledsEntity option_type = new MdmModuleDbFiledsEntity();
            option_type.setMdmId(mdmId);
            option_type.setDbId(dbId);
            option_type.setChName("option_type");
            option_type.setEnName("操作类型");
            option_type.setFiledType("3");
            option_type.setAddType("2");
            option_type.setUpdateType("2");
            option_type.setShowType("2");
            option_type.setQueryType("2");
            option_type.setListType("2");
            option_type.setViewType("2");
            option_type.setFiledLength("255");
            option_type.setDataType("1");
            mdmModuleDbFiledsEntities.add(option_type);
        }
        if("2".equals(type) || "1".equals(type) ) {
            MdmModuleDbFiledsEntity data_status = new MdmModuleDbFiledsEntity();
            data_status.setMdmId(mdmId);
            data_status.setDbId(dbId);
            data_status.setChName("data_status");
            data_status.setEnName("数据状态 Y正常 N删除 F修改");
            data_status.setFiledType("3");
            data_status.setAddType("2");
            data_status.setUpdateType("2");
            data_status.setShowType("2");
            data_status.setQueryType("2");
            data_status.setListType("2");
            data_status.setViewType("2");
            data_status.setFiledLength("1");
            data_status.setDataType("1");
            mdmModuleDbFiledsEntities.add(data_status);
        }
        if("1".equals(type)){
            MdmModuleDbFiledsEntity add_status = new MdmModuleDbFiledsEntity();
            add_status.setMdmId(mdmId);
            add_status.setDbId(dbId);
            add_status.setChName("add_status");
            add_status.setEnName("新增数据状态 0待下发 1已下发");
            add_status.setFiledType("3");
            add_status.setAddType("2");
            add_status.setUpdateType("2");
            add_status.setShowType("2");
            add_status.setQueryType("2");
            add_status.setListType("2");
            add_status.setViewType("2");
            add_status.setFiledLength("1");
            add_status.setDataType("1");
            mdmModuleDbFiledsEntities.add(add_status);
        }
        if("1".equals(type)){
            MdmModuleDbFiledsEntity update_status = new MdmModuleDbFiledsEntity();
            update_status.setMdmId(mdmId);
            update_status.setDbId(dbId);
            update_status.setChName("update_status");
            update_status.setEnName("修改数据状态 0待下发 1已下发");
            update_status.setFiledType("3");
            update_status.setAddType("2");
            update_status.setUpdateType("2");
            update_status.setShowType("2");
            update_status.setQueryType("2");
            update_status.setListType("2");
            update_status.setViewType("2");
            update_status.setFiledLength("1");
            update_status.setDataType("1");
            mdmModuleDbFiledsEntities.add(update_status);
        }

        if("1".equals(type)){
            MdmModuleDbFiledsEntity delete_status = new MdmModuleDbFiledsEntity();
            delete_status.setMdmId(mdmId);
            delete_status.setDbId(dbId);
            delete_status.setChName("delete_status");
            delete_status.setEnName("删除数据状态 0待下发 1已下发");
            delete_status.setFiledType("3");
            delete_status.setAddType("2");
            delete_status.setUpdateType("2");
            delete_status.setShowType("2");
            delete_status.setQueryType("2");
            delete_status.setListType("2");
            delete_status.setViewType("2");
            delete_status.setFiledLength("1");
            delete_status.setDataType("1");
            mdmModuleDbFiledsEntities.add(delete_status);
        }

        MdmModuleDbFiledsEntity sorts = new MdmModuleDbFiledsEntity();
        sorts.setMdmId(mdmId);
        sorts.setDbId(dbId);
        sorts.setChName("sorts");
        sorts.setEnName("排序");
        sorts.setFiledType("1");
        sorts.setAddType("2");
        sorts.setUpdateType("2");
        sorts.setShowType("2");
        sorts.setQueryType("2");
        sorts.setListType("2");
        sorts.setViewType("2");
        sorts.setFiledLength("20");
        sorts.setDataType("1");
        mdmModuleDbFiledsEntities.add(sorts);
        MdmModuleDbFiledsEntity create_user_id = new MdmModuleDbFiledsEntity();
        create_user_id.setMdmId(mdmId);
        create_user_id.setDbId(dbId);
        create_user_id.setChName("create_user_id");
        create_user_id.setEnName("创建人id");
        create_user_id.setFiledType("3");
        create_user_id.setAddType("2");
        create_user_id.setUpdateType("2");
        create_user_id.setShowType("2");
        create_user_id.setQueryType("2");
        create_user_id.setListType("2");
        create_user_id.setViewType("2");
        create_user_id.setFiledLength("50");
        create_user_id.setDataType("1");
        mdmModuleDbFiledsEntities.add(create_user_id);
        MdmModuleDbFiledsEntity create_time = new MdmModuleDbFiledsEntity();
        create_time.setMdmId(mdmId);
        create_time.setDbId(dbId);
        create_time.setChName("create_time");
        create_time.setEnName("创建时间");
        create_time.setFiledType("4");
        create_time.setAddType("2");
        create_time.setUpdateType("2");
        create_time.setShowType("2");
        create_time.setQueryType("2");
        create_time.setListType("2");
        create_time.setViewType("2");
        create_time.setFiledLength("50");
        create_time.setDataType("1");
        mdmModuleDbFiledsEntities.add(create_time);
        MdmModuleDbFiledsEntity modify_user_id = new MdmModuleDbFiledsEntity();
        modify_user_id.setMdmId(mdmId);
        modify_user_id.setDbId(dbId);
        modify_user_id.setChName("modify_user_id");
        modify_user_id.setEnName("修改人id");
        modify_user_id.setFiledType("3");
        modify_user_id.setAddType("2");
        modify_user_id.setUpdateType("2");
        modify_user_id.setShowType("2");
        modify_user_id.setQueryType("2");
        modify_user_id.setListType("2");
        modify_user_id.setViewType("2");
        modify_user_id.setFiledLength("50");
        modify_user_id.setDataType("1");
        mdmModuleDbFiledsEntities.add(modify_user_id);
        MdmModuleDbFiledsEntity modify_time = new MdmModuleDbFiledsEntity();
        modify_time.setMdmId(mdmId);
        modify_time.setDbId(dbId);
        modify_time.setChName("modify_time");
        modify_time.setEnName("修改时间");
        modify_time.setFiledType("4");
        modify_time.setAddType("2");
        modify_time.setUpdateType("2");
        modify_time.setShowType("2");
        modify_time.setQueryType("2");
        modify_time.setListType("2");
        modify_time.setViewType("2");
        modify_time.setFiledLength("50");
        modify_time.setDataType("1");
        mdmModuleDbFiledsEntities.add(modify_time);
        MdmModuleDbFiledsEntity sts = new MdmModuleDbFiledsEntity();
        sts.setMdmId(mdmId);
        sts.setDbId(dbId);
        sts.setChName("sts");
        sts.setEnName("状态(Y正常N删除)");
        sts.setFiledType("3");
        sts.setAddType("2");
        sts.setUpdateType("2");
        sts.setShowType("2");
        sts.setQueryType("2");
        sts.setListType("2");
        sts.setViewType("2");
        sts.setFiledLength("1");
        sts.setDataType("1");
        mdmModuleDbFiledsEntities.add(sts);
        MdmModuleDbFiledsEntity org_id = new MdmModuleDbFiledsEntity();
        org_id.setMdmId(mdmId);
        org_id.setDbId(dbId);
        org_id.setChName("org_id");
        org_id.setEnName("组织机构ID");
        org_id.setFiledType("3");
        org_id.setAddType("2");
        org_id.setUpdateType("2");
        org_id.setShowType("2");
        org_id.setQueryType("2");
        org_id.setListType("2");
        org_id.setViewType("2");
        org_id.setFiledLength("50");
        org_id.setDataType("1");
        mdmModuleDbFiledsEntities.add(org_id);
        MdmModuleDbFiledsEntity company_id = new MdmModuleDbFiledsEntity();
        company_id.setMdmId(mdmId);
        company_id.setDbId(dbId);
        company_id.setChName("company_id");
        company_id.setEnName("公司id");
        company_id.setFiledType("3");
        company_id.setAddType("2");
        company_id.setUpdateType("2");
        company_id.setShowType("2");
        company_id.setQueryType("2");
        company_id.setListType("2");
        company_id.setViewType("2");
        company_id.setFiledLength("50");
        company_id.setDataType("1");
        mdmModuleDbFiledsEntities.add(company_id);
        return mdmModuleDbFiledsEntities;
    }


    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置查询显示信息
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmModuleView(JSONObject object) {
        MdmModuleEntity entity = getData("jsonStr", object, MdmModuleEntity.class);
        //判断分页
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleViewVo mdmModuleViewVo = new MdmModuleViewVo();

        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        //查询数据库字段
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntities = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
        mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbFiledsEntity.setSts("Y");
        List<MdmModuleDbFiledsEntity>  mdmModuleDbFiledsEntities = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity);

        //设置数据库字段
        setFiledType(mdmModuleViewVo,mdmModuleDbEntities,mdmModuleDbFiledsEntities);

        MdmModuleViewDetailEntity mdmModuleViewDetailEntity = new MdmModuleViewDetailEntity();
        mdmModuleViewDetailEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleViewDetailEntity.setSts("Y");
        List<MdmModuleViewDetailEntity>  mdmModuleViewDetailEntities = mdmServiceCache.queryMdmModuleViewDetail(mdmModuleViewDetailEntity);
        setDbFiledType(mdmModuleViewVo,mdmModuleViewDetailEntities);
        MdmModuleViewEntity mdmModuleViewEntity = new MdmModuleViewEntity();
        mdmModuleViewEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleViewEntity.setSts("Y");
        List<MdmModuleViewEntity>  moduleViewEntities = mdmServiceCache.queryMdmModuleView(mdmModuleViewEntity);
        if(moduleViewEntities != null && moduleViewEntities.size() == 1){
            mdmModuleViewVo.setMdmModuleViewEntity(moduleViewEntities.get(0));
        }
        MdmModuleViewButtonEntity mdmModuleViewButtonEntity = new MdmModuleViewButtonEntity();
        mdmModuleViewButtonEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleViewButtonEntity.setSts("Y");
        List<MdmModuleViewButtonEntity>  mdmModuleViewButtonEntities = mdmServiceCache.queryMdmModuleViewButton(mdmModuleViewButtonEntity);
        mdmModuleViewVo.setDbButtonFiled(mdmModuleViewButtonEntities);
        return BaseResult.getSuccessMessageEntity("查询视图成功", mdmModuleViewVo);
    }

    private void setDbFiledType(MdmModuleViewVo mdmModuleViewVo, List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntityList) {
        //新增
        List<MdmModuleViewDetailEntity> addFiled = new ArrayList<>();
        //修改
        List<MdmModuleViewDetailEntity> editFiled = new ArrayList<>();
        //查看
        List<MdmModuleViewDetailEntity> showFiled = new ArrayList<>();
        //查询
        List<MdmModuleViewDetailEntity> queryFiled = new ArrayList<>();
        //列表
        List<MdmModuleViewDetailEntity> listFiled = new ArrayList<>();
        if (mdmModuleViewDetailEntityList != null && mdmModuleViewDetailEntityList.size() > 0) {
            for (int i = 0; i < mdmModuleViewDetailEntityList.size(); i++) {
                switch (mdmModuleViewDetailEntityList.get(i).getViewType()) {
                    //1、查询2、列表3、新增4、修改 5、查看
                    case "1":
                        queryFiled.add(mdmModuleViewDetailEntityList.get(i));
                        break;
                    case "2":
                        listFiled.add(mdmModuleViewDetailEntityList.get(i));
                        break;
                    case "3":
                        addFiled.add(mdmModuleViewDetailEntityList.get(i));
                        break;
                    case "4":
                        editFiled.add(mdmModuleViewDetailEntityList.get(i));
                        break;
                    case "5":
                        showFiled.add(mdmModuleViewDetailEntityList.get(i));
                        break;
                    default:
                }
            }
        }
        mdmModuleViewVo.setDbAddFiled(addFiled);
        mdmModuleViewVo.setDbEditFiled(editFiled);
        mdmModuleViewVo.setDbShowFiled(showFiled);
        mdmModuleViewVo.setDbQueryFiled(queryFiled);
        mdmModuleViewVo.setDbListFiled(listFiled);
    }

    /**
     * @param mdmModuleViewVo
     * @param mdmModuleDbEntityList
     * @param mdmModuleDbFiledsEntityList
     * @return void
     * @Author lvleigang
     * @Description 设置对应的字段类型
     * @Date 2023/10/25
     **/
    private void setFiledType(MdmModuleViewVo mdmModuleViewVo, List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList) {
        //新增
        List<MdmDbFiledVo> addFiled = new ArrayList<>();
        //修改
        List<MdmDbFiledVo> editFiled = new ArrayList<>();
        //查看
        List<MdmDbFiledVo> showFiled = new ArrayList<>();
        //查询
        List<MdmDbFiledVo> queryFiled = new ArrayList<>();
        //列表
        List<MdmDbFiledVo> listFiled = new ArrayList<>();
        if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {

                if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
                    for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                        if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
                            if("1".equals(mdmModuleDbFiledsEntityList.get(i1).getViewType())){
                                if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                                    //1、主表
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getAddType())) {
                                        addFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getUpdateType())) {
                                        editFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getShowType())) {
                                        showFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getQueryType())) {
                                        queryFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getListType())) {
                                        listFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                } else if ("2".equals(mdmModuleDbEntityList.get(i).getDbType())){
                                    //2、明细
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getAddType())) {
                                        addFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getUpdateType())) {
                                        editFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getShowType())) {
                                        showFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getQueryType())) {
                                        queryFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                    if ("1".equals(mdmModuleDbFiledsEntityList.get(i1).getListType())) {
                                        listFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        mdmModuleViewVo.setAddFiled(addFiled);
        mdmModuleViewVo.setEditFiled(editFiled);
        mdmModuleViewVo.setShowFiled(showFiled);
        mdmModuleViewVo.setQueryFiled(queryFiled);
        mdmModuleViewVo.setListFiled(listFiled);
    }
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置修改显示信息
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity doSaveMdmModuleView(JSONObject object) {
        MdmModuleViewDto entity = getData("jsonStr", object, MdmModuleViewDto.class);
        //判断是否有数据
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmModuleViewEntity() == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());

        //保存视图
        MdmModuleViewEntity mdmModuleViewEntity = entity.getMdmModuleViewEntity();
        mdmModuleViewEntity.setMdmId(mdmModuleEntity.getId());
        if(mdmModuleViewEntity.getId() != null && !"".equals(mdmModuleViewEntity.getId())){
            mdmModuleViewEntity.setDataType("2");
            mdmModuleViewEntity.setUpdate();
            mdmServiceCache.saveMdmModuleView(mdmModuleEntity.getId(),mdmModuleViewEntity);
        }else {
            mdmModuleViewEntity.setDataType("1");
            mdmModuleViewEntity.setCreate();
            mdmModuleViewDao.save(mdmModuleViewEntity);
        }
        //保存字段
        List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntities = new ArrayList<>();
        //1、查询2、列表3、新增4、修改 5、查看
        saveDbViewFiled(mdmModuleEntity.getId(),mdmModuleViewEntity.getId(),entity.getQueryFiled(),"1",mdmModuleViewDetailEntities);
        saveDbViewFiled(mdmModuleEntity.getId(),mdmModuleViewEntity.getId(),entity.getListFiled(),"2",mdmModuleViewDetailEntities);
        saveDbViewFiled(mdmModuleEntity.getId(),mdmModuleViewEntity.getId(),entity.getAddFiled(),"3",mdmModuleViewDetailEntities);
        saveDbViewFiled(mdmModuleEntity.getId(),mdmModuleViewEntity.getId(),entity.getEditFiled(),"4",mdmModuleViewDetailEntities);
        saveDbViewFiled(mdmModuleEntity.getId(),mdmModuleViewEntity.getId(),entity.getShowFiled(),"5",mdmModuleViewDetailEntities);
        mdmServiceCache.saveMdmModuleViewDetail(mdmModuleEntity.getId(),mdmModuleViewDetailEntities);
        //保存按钮
        List<MdmModuleViewButtonEntity> mdmModuleViewButtonEntities = entity.getDbButtonFiled();
        if(mdmModuleViewButtonEntities != null && mdmModuleViewButtonEntities.size() > 0){
            for (int i = 0; i < mdmModuleViewButtonEntities.size(); i++) {
                mdmModuleViewButtonEntities.get(i).setMdmId(mdmModuleEntity.getId());
                mdmModuleViewButtonEntities.get(i).setViewId(mdmModuleViewEntity.getId());
                if(mdmModuleViewButtonEntities.get(i).getId() != null && !"".equals(mdmModuleViewButtonEntities.get(i).getId())){
                    mdmModuleViewButtonEntities.get(i).setDataType("2");
                    mdmModuleViewButtonEntities.get(i).setUpdate();
                }else {
                    mdmModuleViewButtonEntities.get(i).setDataType("1");
                    mdmModuleViewButtonEntities.get(i).setCreate();
                }
            }
            mdmServiceCache.saveMdmModuleViewButton(mdmModuleEntity.getId(),mdmModuleViewButtonEntities);
        }

        //保存菜单
        //保存按钮

        if("1".equals(mdmModuleViewEntity.getDataType())){
           //新增
            SysMenuConfigEntity module = new SysMenuConfigEntity();
            module.setCreate();
            module.setFormId(mdmModuleEntity.getId());
            if("1".equals(mdmModuleEntity.getMdmType())){
                //1、档案
                module.setParentMenuId("ea22757e99c144fb9ef381dd322e233c");
            }else {
                //2、单据
                module.setParentMenuId("58714ddb7ec94f5da91df74efada042f");
            }
            module.setMenuName(mdmModuleEntity.getMdmName());
            module.setMenuEnglishName("integrationOptionAdmin" + mdmModuleEntity.getMdmCode());
            module.setMenuIcon(null);//模块图标
            module.setRoute("integrationOptionAdmin/" + mdmModuleEntity.getMdmCode());//路由地址
            module.setMenuPage("integrationOptionV2/index");//一级Layout 二级 ParntView 三级component
            module.setRemark("主数据生成菜单");
            module.setVisibles("0");
            module.setShowType("1");
            JSONObject object1 = new JSONObject();
            object1.put("mdmId", mdmModuleEntity.getId());//主数据id
            object1.put("mdmCode", mdmModuleEntity.getMdmCode());//主数据编码
            object1.put("viewType", mdmModuleViewEntity.getViewName());//1、树 2、列表
            module.setOptions(object1.toString());//菜单mate参数
            sysMenuConfigDao.save(module);
            if(mdmModuleViewButtonEntities != null && mdmModuleViewButtonEntities.size() > 0){
                for (int i = 0; i < mdmModuleViewButtonEntities.size(); i++) {
                    if("new".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())){
                        SysButtonConfigEntity xz = new SysButtonConfigEntity();
                        xz.setCode("new");
                        xz.setNameCh("新建");
                        xz.setNameEn("new");
                        xz.setMenuId(module.getId());
                        xz.setIconName("");
                        xz.setStyles("");
                        xz.setBtnFunction("new");
                        xz.setRemark("主数据新建按钮");
                        xz.setCreate();
                        sysButtonConfigDao.save(xz);
                    }
                    if("resize".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())){

                        SysButtonConfigEntity cz = new SysButtonConfigEntity();
                        cz.setCode("resize");
                        cz.setNameCh("重置");
                        cz.setNameEn("resize");
                        cz.setMenuId(module.getId());
                        cz.setIconName("");
                        cz.setStyles("");
                        cz.setBtnFunction("resize");
                        cz.setRemark("主数据重置按钮");
                        cz.setCreate();
                        sysButtonConfigDao.save(cz);
                    }
                    if("search".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {

                        SysButtonConfigEntity cx = new SysButtonConfigEntity();
                        cx.setCode("search");
                        cx.setNameCh("查询");
                        cx.setNameEn("search");
                        cx.setMenuId(module.getId());
                        cx.setIconName("");
                        cx.setStyles("");
                        cx.setBtnFunction("search");
                        cx.setRemark("主数据查询按钮");
                        cx.setCreate();
                        sysButtonConfigDao.save(cx);
                    }
                    if("edit".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {

                        SysButtonConfigEntity xg = new SysButtonConfigEntity();
                        xg.setCode("edit");
                        xg.setNameCh("修改");
                        xg.setNameEn("edit");
                        xg.setMenuId(module.getId());
                        xg.setIconName("");
                        xg.setStyles("");
                        xg.setBtnFunction("edit");
                        xg.setRemark("主数据修改按钮");
                        xg.setCreate();
                        sysButtonConfigDao.save(xg);
                    }
                    if("dele".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {

                        SysButtonConfigEntity sc = new SysButtonConfigEntity();
                        sc.setCode("dele");
                        sc.setNameCh("删除");
                        sc.setNameEn("dele");
                        sc.setMenuId(module.getId());
                        sc.setIconName("");
                        sc.setStyles("");
                        sc.setBtnFunction("dele");
                        sc.setRemark("主数据删除按钮");
                        sc.setCreate();
                        sysButtonConfigDao.save(sc);
                    }
                    if("view".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {

                        SysButtonConfigEntity ck = new SysButtonConfigEntity();
                        ck.setCode("view");
                        ck.setNameCh("查看");
                        ck.setNameEn("view");
                        ck.setMenuId(module.getId());
                        ck.setIconName("");
                        ck.setStyles("");
                        ck.setBtnFunction("view");
                        ck.setRemark("主数据查看按钮");
                        ck.setCreate();
                        sysButtonConfigDao.save(ck);
                    }
                    if("send".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {
                        SysButtonConfigEntity xf = new SysButtonConfigEntity();
                        xf.setCode("send");
                        xf.setNameCh("下发");
                        xf.setNameEn("send");
                        xf.setMenuId(module.getId());
                        xf.setIconName("");
                        xf.setStyles("");
                        xf.setBtnFunction("send");
                        xf.setRemark("主数据下发按钮");
                        xf.setCreate();
                        sysButtonConfigDao.save(xf);
                    }
                }
            }
        }else {
            //修改
            //修改菜单 注意因为可能修改显示类型，所以需要修改菜单的属性
            SysMenuConfigEntity module = new SysMenuConfigEntity();
            module.setFormId(mdmModuleEntity.getId());
            module.setSts("Y");
            List<SysMenuConfigEntity> moduleList = sysMenuConfigDao.queryBase(module);
            if (moduleList != null && moduleList.size() == 1) {
                module = moduleList.get(0);
                module.setUpdate();
                module.setMenuName(mdmModuleEntity.getMdmName());
                JSONObject object1 = new JSONObject();
                object1.put("mdmId", mdmModuleEntity.getId());//主数据id
                object1.put("mdmCode", mdmModuleEntity.getMdmCode());//主数据id
                object1.put("viewType", mdmModuleViewEntity.getViewName());//1、树 2、列表
                module.setOptions(object1.toString());//菜单mate参数
                sysMenuConfigDao.update(module);
                //修改按钮
                //1、查询所有按钮
                SysButtonConfigEntity buttonConfigEntity = new SysButtonConfigEntity();
                buttonConfigEntity.setMenuId(module.getId());
                buttonConfigEntity.setSts("Y");
                List<SysButtonConfigEntity> sysButtonConfigEntities = sysButtonConfigDao.queryBase(buttonConfigEntity);
                //1、查询按钮权限
                SysPopedomOperateEntity sysPopedomOperateEntity = new SysPopedomOperateEntity();
                sysPopedomOperateEntity.setMenuId(module.getId());
                sysPopedomOperateEntity.setSts("Y");
                List<SysPopedomOperateEntity> sysPopedomOperateEntities = sysPopedomOperateDao.queryBase(sysPopedomOperateEntity);
                //删除按钮和删除按钮权限
                sysButtonConfigDao.logicRemoveMultiCondition(buttonConfigEntity);
                sysPopedomOperateDao.logicRemoveMultiCondition(sysPopedomOperateEntity);
                //删除处理权限
                doMdmModuleButton(module,mdmModuleViewButtonEntities,sysButtonConfigEntities,sysPopedomOperateEntities);
            }
        }
        return BaseResult.getSuccessMessageEntity("保存显示信息成功");
    }

    /**
     * @Author lvleigang
     * @Description
     * @Date 3:29 下午 2024/6/4
     * @param module 菜单
     * @param mdmModuleViewButtonEntities 主数据按钮
     * @param sysButtonConfigEntities 菜单按钮
     * @param sysPopedomOperateEntities 按钮权限
     * @return void
     **/
    private void doMdmModuleButton(SysMenuConfigEntity module,List<MdmModuleViewButtonEntity> mdmModuleViewButtonEntities, List<SysButtonConfigEntity> sysButtonConfigEntities, List<SysPopedomOperateEntity> sysPopedomOperateEntities) {
        //循环设置的按钮，再循环菜单的按钮，如果有把原先的修改状态，如果没有新增
        if(mdmModuleViewButtonEntities != null && mdmModuleViewButtonEntities.size() > 0){
            for (int i = 0; i < mdmModuleViewButtonEntities.size(); i++) {
                boolean flag = false;
                if(sysButtonConfigEntities != null && sysButtonConfigEntities.size() > 0){
                    for (int i1 = 0; i1 < sysButtonConfigEntities.size(); i1++) {
                        if(mdmModuleViewButtonEntities.get(i).getButtonValue().equals(sysButtonConfigEntities.get(i1).getCode())){
                            flag = true;
                            sysButtonConfigEntities.get(i1).setSts("Y");
                            sysButtonConfigEntities.get(i1).setUpdate();
                            sysButtonConfigDao.update(sysButtonConfigEntities.get(i1));
                            if(sysPopedomOperateEntities != null && sysPopedomOperateEntities.size() > 0){
                                for (int i2 = 0; i2 < sysPopedomOperateEntities.size(); i2++) {
                                    if(sysPopedomOperateEntities.get(i2).getOperate().equals(sysButtonConfigEntities.get(i1).getId())){
                                        sysPopedomOperateEntities.get(i2).setSts("Y");
                                        sysPopedomOperateEntities.get(i2).setUpdate();
                                        sysPopedomOperateDao.update(sysPopedomOperateEntities.get(i2));
                                    }
                                }
                            }
                            break;
                        }
                    }
                }
                //原先没有需要新增
                if(!flag){
                    if("new".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())){
                        SysButtonConfigEntity xz = new SysButtonConfigEntity();
                        xz.setCode("new");
                        xz.setNameCh("新建");
                        xz.setNameEn("new");
                        xz.setMenuId(module.getId());
                        xz.setIconName("");
                        xz.setStyles("");
                        xz.setBtnFunction("new");
                        xz.setRemark("主数据新建按钮");
                        xz.setCreate();
                        sysButtonConfigDao.save(xz);
                    }
                    if("resize".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())){

                        SysButtonConfigEntity cz = new SysButtonConfigEntity();
                        cz.setCode("resize");
                        cz.setNameCh("重置");
                        cz.setNameEn("resize");
                        cz.setMenuId(module.getId());
                        cz.setIconName("");
                        cz.setStyles("");
                        cz.setBtnFunction("resize");
                        cz.setRemark("主数据重置按钮");
                        cz.setCreate();
                        sysButtonConfigDao.save(cz);
                    }
                    if("search".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {

                        SysButtonConfigEntity cx = new SysButtonConfigEntity();
                        cx.setCode("search");
                        cx.setNameCh("查询");
                        cx.setNameEn("search");
                        cx.setMenuId(module.getId());
                        cx.setIconName("");
                        cx.setStyles("");
                        cx.setBtnFunction("search");
                        cx.setRemark("主数据查询按钮");
                        cx.setCreate();
                        sysButtonConfigDao.save(cx);
                    }
                    if("edit".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {

                        SysButtonConfigEntity xg = new SysButtonConfigEntity();
                        xg.setCode("edit");
                        xg.setNameCh("修改");
                        xg.setNameEn("edit");
                        xg.setMenuId(module.getId());
                        xg.setIconName("");
                        xg.setStyles("");
                        xg.setBtnFunction("edit");
                        xg.setRemark("主数据修改按钮");
                        xg.setCreate();
                        sysButtonConfigDao.save(xg);
                    }
                    if("dele".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {

                        SysButtonConfigEntity sc = new SysButtonConfigEntity();
                        sc.setCode("dele");
                        sc.setNameCh("删除");
                        sc.setNameEn("dele");
                        sc.setMenuId(module.getId());
                        sc.setIconName("");
                        sc.setStyles("");
                        sc.setBtnFunction("dele");
                        sc.setRemark("主数据删除按钮");
                        sc.setCreate();
                        sysButtonConfigDao.save(sc);
                    }
                    if("view".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {

                        SysButtonConfigEntity ck = new SysButtonConfigEntity();
                        ck.setCode("view");
                        ck.setNameCh("查看");
                        ck.setNameEn("view");
                        ck.setMenuId(module.getId());
                        ck.setIconName("");
                        ck.setStyles("");
                        ck.setBtnFunction("view");
                        ck.setRemark("主数据查看按钮");
                        ck.setCreate();
                        sysButtonConfigDao.save(ck);
                    }
                    if("send".equals(mdmModuleViewButtonEntities.get(i).getButtonValue())) {
                        SysButtonConfigEntity xf = new SysButtonConfigEntity();
                        xf.setCode("send");
                        xf.setNameCh("下发");
                        xf.setNameEn("send");
                        xf.setMenuId(module.getId());
                        xf.setIconName("");
                        xf.setStyles("");
                        xf.setBtnFunction("send");
                        xf.setRemark("主数据下发按钮");
                        xf.setCreate();
                        sysButtonConfigDao.save(xf);
                    }


                }
            }
        }
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置查询分发设置
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmModuleDistribute(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询模块下的应用列表
        MdmModuleDistributeEntity mdmModuleDistributeEntity = new MdmModuleDistributeEntity();
        mdmModuleDistributeEntity.setSts("Y");
        mdmModuleDistributeEntity.setMdmId(mdmModuleEntity.getId());
        List<MdmModuleDistributeEntity> mdmModuleDistributeEntities = mdmServiceCache.queryMdmModuleDistribute(mdmModuleEntity.getId(),mdmModuleDistributeEntity);
        return BaseResult.getSuccessMessageEntity("查询成功", mdmModuleDistributeEntities);
    }
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置保存分发设置
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity doSaveMdmModuleDistribute(JSONObject object) {
        MdmDistributeDto entity = getData("jsonStr", object, MdmDistributeDto.class);
        //判断是否有数据
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        mdmServiceCache.saveMdmModuleDistribute(mdmModuleEntity.getId(),entity.getMdmModuleDistributeEntities());
        return BaseResult.getSuccessMessageEntity("保存发布设置成功");
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置查询数据来源
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmModuleSource(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询模块下的应用列表
        MdmModuleSourceEntity mdmModuleSourceEntity = new MdmModuleSourceEntity();
        mdmModuleSourceEntity.setSts("Y");
        mdmModuleSourceEntity.setMdmId(mdmModuleEntity.getId());
        List<MdmModuleSourceEntity> mdmModuleSourceEntities = mdmServiceCache.queryMdmModuleSource(mdmModuleSourceEntity);
        return BaseResult.getSuccessMessageEntity("查询成功", mdmModuleSourceEntities);
    }
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置保存数据来源
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity doSaveMdmModuleSource(JSONObject object) {
        MdmSourceDto entity = getData("jsonStr", object, MdmSourceDto.class);
        //判断是否有数据
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        mdmServiceCache.saveMdmModuleSource(mdmModuleEntity.getId(),entity.getMdmModuleSourceEntities());
        return BaseResult.getSuccessMessageEntity("保存发布设置成功");
    }

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 查询下发日志
     * @Date 11:52 上午 2024/3/27
     **/
    @Override
    public JsonResultEntity querySendEntityPage(JSONObject jsonObject) {
        MdmModuleSendLogEntity entity = getData("jsonStr", jsonObject, MdmModuleSendLogEntity.class);
        //判断分页
        if (entity == null || entity.getPageNum() == null || entity.getPageSize() == null) {
            return BaseResult.getFailureMessageEntity("分页查询参数不存在");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntities = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if(mdmModuleDbEntities != null && mdmModuleDbEntities.size() > 0 ){
            for (int i = 0; i < mdmModuleDbEntities.size(); i++) {
                if("1".equals(mdmModuleDbEntities.get(i).getDbType())){
                    entity.setTableName(mdmModuleDbEntities.get(i).getDbName()+"_send_log");
                    break;
                }
            }
        }else {
            return BaseResult.getFailureMessageEntity("请先设置数据源");
        }
        PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
        List<MdmModuleSendLogEntity> list = mdmModuleSendLogDao.queryByLike(entity);
        PageInfo pageInfo = new PageInfo(list);
        return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
    }

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 获取下发日志
     * @Date 2:36 下午 2024/3/27
     **/
    @Override
    public JsonResultEntity getSendEntity(JSONObject jsonObject) {
        MdmModuleSendLogEntity entity = getData("jsonStr", jsonObject, MdmModuleSendLogEntity.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getId() == null || "".equals(entity.getId())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntities = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if(mdmModuleDbEntities != null && mdmModuleDbEntities.size() > 0 ){
            for (int i = 0; i < mdmModuleDbEntities.size(); i++) {
                if("1".equals(mdmModuleDbEntities.get(i).getDbType())){
                    entity.setTableName(mdmModuleDbEntities.get(i).getDbName()+"_send_log");
                    break;
                }
            }
        }else {
            return BaseResult.getFailureMessageEntity("请先设置数据源");
        }
        entity = mdmModuleSendLogDao.get(entity.getId());
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("获取日志失败");
        }
        return BaseResult.getSuccessMessageEntity("获取日志成功", entity);
    }

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 删除下发日志
     * @Date 2:37 下午 2024/3/27
     **/
    @Override
    public JsonResultEntity deleteSendEntity(JSONObject jsonObject) {
        MdmModuleSendLogEntity entity = getData("jsonStr", jsonObject, MdmModuleSendLogEntity.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getId() == null || "".equals(entity.getId())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntities = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if(mdmModuleDbEntities != null && mdmModuleDbEntities.size() > 0 ){
            for (int i = 0; i < mdmModuleDbEntities.size(); i++) {
                if("1".equals(mdmModuleDbEntities.get(i).getDbType())){
                    entity.setTableName(mdmModuleDbEntities.get(i).getDbName()+"_send_log");
                    break;
                }
            }
        }else {
            return BaseResult.getFailureMessageEntity("请先设置数据源");
        }
        entity.setUpdate();
        mdmModuleSendLogDao.logicRemove(entity);
        return BaseResult.getSuccessMessageEntity("删除日志成功");
    }



    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 查询操作日志
     * @Date 11:52 上午 2024/3/27
     **/
    @Override
    public JsonResultEntity queryOptionEntityPage(JSONObject jsonObject) {
        MdmModuleOptionLogEntity entity = getData("jsonStr", jsonObject, MdmModuleOptionLogEntity.class);
        //判断分页
        if (entity == null || entity.getPageNum() == null || entity.getPageSize() == null) {
            return BaseResult.getFailureMessageEntity("分页查询参数不存在");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntities = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if(mdmModuleDbEntities != null && mdmModuleDbEntities.size() > 0 ){
            for (int i = 0; i < mdmModuleDbEntities.size(); i++) {
                if("1".equals(mdmModuleDbEntities.get(i).getDbType())){
                    entity.setTableName(mdmModuleDbEntities.get(i).getDbName()+"_option_log");
                    break;
                }
            }
        }else {
            return BaseResult.getFailureMessageEntity("请先设置数据源");
        }
        PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
        List<MdmModuleOptionLogEntity> list = mdmModuleOptionLogDao.queryByLike(entity);
        PageInfo pageInfo = new PageInfo(list);
        return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
    }

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 获取操作日志
     * @Date 2:36 下午 2024/3/27
     **/
    @Override
    public JsonResultEntity getOptionEntity(JSONObject jsonObject) {
        MdmModuleOptionLogEntity entity = getData("jsonStr", jsonObject, MdmModuleOptionLogEntity.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getId() == null || "".equals(entity.getId())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntities = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if(mdmModuleDbEntities != null && mdmModuleDbEntities.size() > 0 ){
            for (int i = 0; i < mdmModuleDbEntities.size(); i++) {
                if("1".equals(mdmModuleDbEntities.get(i).getDbType())){
                    entity.setTableName(mdmModuleDbEntities.get(i).getDbName()+"_option_log");
                    break;
                }
            }
        }else {
            return BaseResult.getFailureMessageEntity("请先设置数据源");
        }
        entity = mdmModuleOptionLogDao.get(entity.getId());
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("获取日志失败");
        }
        return BaseResult.getSuccessMessageEntity("获取日志成功", entity);
    }

    /**
     * @param jsonObject
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 删除操作日志
     * @Date 2:37 下午 2024/3/27
     **/
    @Override
    public JsonResultEntity deleteOptionEntity(JSONObject jsonObject) {
        MdmModuleOptionLogEntity entity = getData("jsonStr", jsonObject, MdmModuleOptionLogEntity.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getId() == null || "".equals(entity.getId())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntities = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if(mdmModuleDbEntities != null && mdmModuleDbEntities.size() > 0 ){
            for (int i = 0; i < mdmModuleDbEntities.size(); i++) {
                if("1".equals(mdmModuleDbEntities.get(i).getDbType())){
                    entity.setTableName(mdmModuleDbEntities.get(i).getDbName()+"_option_log");
                    break;
                }
            }
        }else {
            return BaseResult.getFailureMessageEntity("请先设置数据源");
        }
        entity.setUpdate();
        mdmModuleOptionLogDao.logicRemove(entity);
        return BaseResult.getSuccessMessageEntity("删除日志成功");
    }
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置查询数据源的服务
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmModuleServer(JSONObject object) {
        MdmModuleDbEntity entity = getData("jsonStr", object, MdmModuleDbEntity.class);
        //判断分页
        if (entity == null) {
            entity = new MdmModuleDbEntity();
        }
        //查询数据源表
        entity.setSts("Y");
        List<MdmModuleDbEntity> allDb = mdmModuleDbDao.queryByLike(entity);
        List<MdmModuleDbEntity> mdmModuleDbEntityList = new ArrayList<>();
        if(allDb != null && allDb.size() > 0){
            for (int i = 0; i < allDb.size(); i++) {
                if("1".equals(allDb.get(i).getDbType()) || "2".equals(allDb.get(i).getDbType() )){
                    mdmModuleDbEntityList.add(allDb.get(i));
                }
            }
        }
        return BaseResult.getSuccessMessageEntity("查询数据成功", mdmModuleDbEntityList);
    }

    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置查询数据源的服务的字段
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmModuleServerFiled(JSONObject object) {
        MdmModuleDbEntity entity = getData("jsonStr", object, MdmModuleDbEntity.class);
        //判断分页
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getDbName() == null || "".equals(entity.getDbName())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源表
        entity.setSts("Y");
        List<MdmModuleDbEntity> dblist = mdmModuleDbDao.queryBase(entity);
        if (dblist != null && dblist.size() == 1) {
            MdmModuleDbFiledsEntity queryDbFiled = new MdmModuleDbFiledsEntity();
            queryDbFiled.setSts("Y");
            queryDbFiled.setDbId(dblist.get(0).getId());
            queryDbFiled.setViewType("1");
            List<MdmModuleDbFiledsEntity> list = mdmModuleDbFiledsDao.queryBase(queryDbFiled);
            MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
            mdmModuleDbFiledsEntity.setChName("id");
            mdmModuleDbFiledsEntity.setEnName("id");
            list.add(0, mdmModuleDbFiledsEntity);
            return BaseResult.getSuccessMessageEntity("查询数据成功", list);
        } else {
            return BaseResult.getFailureMessageEntity("服务不存在");
        }
    }
    //
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据设置查询主表字段
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmModuleServerMainFiled(JSONObject object) {
        MdmModuleDbEntity entity = getData("jsonStr", object, MdmModuleDbEntity.class);
        //判断分页
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmId() == null || "".equals(entity.getMdmId())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源表
        entity.setSts("Y");
        entity.setDbType("1");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(entity);
        if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() == 1) {
            MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
            mdmModuleDbFiledsEntity.setSts("Y");
            mdmModuleDbFiledsEntity.setViewType("1");
            mdmModuleDbFiledsEntity.setDbId(mdmModuleDbEntityList.get(0).getId());
            List<MdmModuleDbFiledsEntity> list = mdmModuleDbFiledsDao.queryBase(mdmModuleDbFiledsEntity);
            return BaseResult.getSuccessMessageEntity("查询数据成功", list);
        } else if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("请先配置数据源");
        } else {
            return BaseResult.getFailureMessageEntity("查询数据失败");
        }
    }



    //
    ///**
    // * @param entity
    // * @param mainMdmModuleDb
    // * @param mainMdmModuleDbFileds
    // * @return void
    // * @Author lvleigang
    // * @Description 设置保存主表和字段以及字段的属性
    // * @Date 10:34 上午 2023/10/19
    // **/
    //private void setMainTable(MdmDto entity, MdmModuleDbEntity mainMdmModuleDb, List<MdmModuleDbFiledsEntity> mainMdmModuleDbFileds) {
    //    //先保存或修改主表数据
    //    mainMdmModuleDb.setMdmId(entity.getId());
    //    mainMdmModuleDb.setDbType("1");
    //    boolean flag = false;
    //
    //    if (mainMdmModuleDb.getId() != null && !"".equals(mainMdmModuleDb.getId())) {
    //        mainMdmModuleDb.setSts("Y");
    //        mainMdmModuleDb.setModify_user_id(StpUtil.getLoginIdAsString());
    //        mainMdmModuleDb.setModify_time(new Date());
    //        mdmModuleDbDao.update(mainMdmModuleDb);
    //        //删除规则表
    //        MdmModuleDbFiledsRuleEntity delectFiledsRule = new MdmModuleDbFiledsRuleEntity();
    //        delectFiledsRule.setMdmId(entity.getId());
    //        delectFiledsRule.setModify_user_id(StpUtil.getLoginIdAsString());
    //        delectFiledsRule.setModify_time(new Date());
    //        mdmModuleDbFiledsRuleDao.logicRemoveMultiCondition(delectFiledsRule);
    //    } else {
    //        flag = true;
    //        mainMdmModuleDb.setId(UUIDUtils.getUUID());
    //        mainMdmModuleDb.setSts("Y");
    //        mainMdmModuleDb.setCreate_user_id(StpUtil.getLoginIdAsString());
    //        mainMdmModuleDb.setModify_user_id(StpUtil.getLoginIdAsString());
    //        mainMdmModuleDb.setCreate_time(new Date());
    //        mainMdmModuleDb.setModify_time(new Date());
    //        mdmModuleDbDao.save(mainMdmModuleDb);
    //    }
    //    List<DbFiledsDto> dbFiledsDtos = new ArrayList<>();
    //
    //    //保存主表字段 因为字段不允许删除，所以不用先删除再新增
    //    if (mainMdmModuleDbFileds != null && mainMdmModuleDbFileds.size() > 0) {
    //        for (int i = 0; i < mainMdmModuleDbFileds.size(); i++) {
    //            MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = mainMdmModuleDbFileds.get(i);
    //            mdmModuleDbFiledsEntity.setMdmId(entity.getId());
    //            mdmModuleDbFiledsEntity.setDbId(mainMdmModuleDb.getId());
    //            if (mdmModuleDbFiledsEntity.getId() != null && !"".equals(mdmModuleDbFiledsEntity.getId())) {
    //                DbFiledsDto dbFiledsDto = new DbFiledsDto("1", mdmModuleDbFiledsEntity.getChName(), mdmModuleDbFiledsEntity.getEnName(), mdmModuleDbFiledsEntity.getFiledType(), mdmModuleDbFiledsEntity.getFiledLength());
    //                dbFiledsDtos.add(dbFiledsDto);
    //
    //                mdmModuleDbFiledsEntity.setSts("Y");
    //                mdmModuleDbFiledsEntity.setModify_user_id(StpUtil.getLoginIdAsString());
    //                mdmModuleDbFiledsEntity.setModify_time(new Date());
    //                mdmModuleDbFiledsDao.update(mdmModuleDbFiledsEntity);
    //            } else {
    //                DbFiledsDto dbFiledsDto = new DbFiledsDto("2", mdmModuleDbFiledsEntity.getChName(), mdmModuleDbFiledsEntity.getEnName(), mdmModuleDbFiledsEntity.getFiledType(), mdmModuleDbFiledsEntity.getFiledLength());
    //                dbFiledsDtos.add(dbFiledsDto);
    //                mdmModuleDbFiledsEntity.setId(UUIDUtils.getUUID());
    //                mdmModuleDbFiledsEntity.setSts("Y");
    //                mdmModuleDbFiledsEntity.setCreate_user_id(StpUtil.getLoginIdAsString());
    //                mdmModuleDbFiledsEntity.setModify_user_id(StpUtil.getLoginIdAsString());
    //                mdmModuleDbFiledsEntity.setCreate_time(new Date());
    //                mdmModuleDbFiledsEntity.setModify_time(new Date());
    //                mdmModuleDbFiledsDao.save(mdmModuleDbFiledsEntity);
    //            }
    //            //修改或保存属性
    //            List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRules = mdmModuleDbFiledsEntity.getMdmModuleDbFiledsRules();
    //            if (mdmModuleDbFiledsRules != null && mdmModuleDbFiledsRules.size() > 0) {
    //                for (int a = 0; a < mdmModuleDbFiledsRules.size(); a++) {
    //                    MdmModuleDbFiledsRuleEntity mdmModuleDbFiledsRuleEntity = mdmModuleDbFiledsRules.get(a);
    //                    mdmModuleDbFiledsRuleEntity.setMdmId(entity.getId());
    //                    mdmModuleDbFiledsRuleEntity.setDbId(mainMdmModuleDb.getId());
    //                    mdmModuleDbFiledsRuleEntity.setFiledId(mdmModuleDbFiledsEntity.getId());
    //                    if (mdmModuleDbFiledsRuleEntity.getId() != null && !"".equals(mdmModuleDbFiledsRuleEntity.getId())) {
    //                        mdmModuleDbFiledsRuleEntity.setSts("Y");
    //                        mdmModuleDbFiledsRuleEntity.setModify_user_id(StpUtil.getLoginIdAsString());
    //                        mdmModuleDbFiledsRuleEntity.setModify_time(new Date());
    //                        mdmModuleDbFiledsRuleDao.update(mdmModuleDbFiledsRuleEntity);
    //                    } else {
    //                        mdmModuleDbFiledsRuleEntity.setId(UUIDUtils.getUUID());
    //                        mdmModuleDbFiledsRuleEntity.setSts("Y");
    //                        mdmModuleDbFiledsRuleEntity.setCreate_user_id(StpUtil.getLoginIdAsString());
    //                        mdmModuleDbFiledsRuleEntity.setModify_user_id(StpUtil.getLoginIdAsString());
    //                        mdmModuleDbFiledsRuleEntity.setCreate_time(new Date());
    //                        mdmModuleDbFiledsRuleEntity.setModify_time(new Date());
    //                        mdmModuleDbFiledsRuleDao.save(mdmModuleDbFiledsRuleEntity);
    //                    }
    //                }
    //            }
    //        }
    //    }
    //    if (flag) {
    //        //新增
    //        Map<String, Object> maps = new HashMap<>();
    //        maps.put("dbType", "1");//表类型
    //        maps.put("tableName", mainMdmModuleDb.getDbName());//表名
    //        maps.put("tableRemark", mainMdmModuleDb.getRemark());//表备注
    //        maps.put("databaseFields", dbFiledsDtos);//字段
    //        mdmModuleDao.createTable(maps);
    //        Map<String, Object> mapsDistribute = new HashMap<>();
    //        mapsDistribute.put("tableName", mainMdmModuleDb.getDbName() + "_distribute");//表名
    //        List<DbFiledsDto> distribute = getDistribute();
    //        maps.put("databaseFields", distribute);//字段
    //        mapsDistribute.put("tableRemark", mainMdmModuleDb.getRemark() + "分发表");//表备注
    //        mdmModuleDao.createTableDistribute(mapsDistribute);
    //    } else {
    //        //修改
    //        Map<String, String> tablename = new HashMap<>();
    //        tablename.put("tableName", mainMdmModuleDb.getDbName());//表名
    //        tablename.put("tableRemark", mainMdmModuleDb.getRemark());//表备注
    //        mdmModuleDao.alterTableName(tablename);
    //        Map<String, Object> maps = new HashMap<>();
    //        maps.put("tableName", mainMdmModuleDb.getDbName());//表名
    //        maps.put("tableRemark", mainMdmModuleDb.getRemark());//表备注
    //        maps.put("databaseFields", dbFiledsDtos);//字段
    //        mdmModuleDao.alterTable(maps);
    //    }
    //}
    //
    ///**
    // * @param
    // * @return java.util.List<com.hzya.frame.mdm.entity.DbFiledsDto>
    // * @Author lvleigang
    // * @Description 设置分发表字段
    // * @Date 8:49 上午 2023/11/9
    // **/
    //private List<DbFiledsDto> getDistribute() {
    //    List<DbFiledsDto> dbFiledsDtos = new ArrayList<>();
    //    dbFiledsDtos.add(new DbFiledsDto("1", "数据id", "formmain_id", "3", "50"));
    //    dbFiledsDtos.add(new DbFiledsDto("1", "应用id", "app_id", "3", "50"));
    //    dbFiledsDtos.add(new DbFiledsDto("1", "状态1、发送成功 2、发送中 3、发送失败", "status", "3", "50"));
    //    dbFiledsDtos.add(new DbFiledsDto("1", "描述", "msg", "3", "50"));
    //    return dbFiledsDtos;
    //}
    //
    /**
     * @param tableName
     * @return java.lang.Long
     * @Author lvleigang
     * @Description 校验表是否存在
     * @Date 3:58 下午 2023/7/11
     **/
    private boolean checkTable(String tableName) {
        Map<String, String> maps = new HashMap<>();
        maps.put("tableName", tableName);
        Integer i = mdmModuleDao.checkTable(maps);
        if (i != null && i > 0) {
            return true;
        }
        return false;
    }
    //
    ///**
    // * @param object
    // * @return com.hzya.frame.web.entity.JsonResultEntity
    // * @Author lvleigang
    // * @Description 主数据设置查询显示信息
    // * @Date 9:40 上午 2023/10/18
    // **/
    //@Override
    //public JsonResultEntity queryMdmModuleView(JSONObject object) {
    //    MdmDto entity = getData("jsonStr", object, MdmDto.class);
    //    if (entity == null) {
    //        return BaseResult.getFailureMessageEntity("参数不允许为空");
    //    }
    //    if (entity.getId() == null || "".equals(entity.getId())) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    MdmModuleViewVo mdmModuleViewVo = new MdmModuleViewVo();
    //    //查询设置各种类型字段
    //    //查询模版数据源
    //    MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
    //    mdmModuleDbEntity.setMdmId(entity.getId());
    //    mdmModuleDbEntity.setSts("Y");
    //    List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(mdmModuleDbEntity);
    //    if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
    //        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
    //        mdmModuleDbFiledsEntity.setMdmId(entity.getId());
    //        mdmModuleDbFiledsEntity.setSts("Y");
    //        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmModuleDbFiledsDao.queryBase(mdmModuleDbFiledsEntity);
    //        setFiledType(mdmModuleViewVo, mdmModuleDbEntityList, mdmModuleDbFiledsEntityList);
    //    }
    //    //查询数据库设置的字段
    //    MdmModuleViewEntity mdmModuleViewEntity = new MdmModuleViewEntity();
    //    mdmModuleViewEntity.setMdmId(entity.getId());
    //    mdmModuleViewEntity.setSts("Y");
    //    List<MdmModuleViewEntity> moduleViewEntityList = mdmModuleViewDao.queryBase(mdmModuleViewEntity);
    //    if (moduleViewEntityList != null && moduleViewEntityList.size() == 1) {
    //        mdmModuleViewVo.setMdmModuleViewEntity(moduleViewEntityList.get(0));
    //        //查询明细
    //        MdmModuleViewDetailEntity mdmModuleViewDetailEntity = new MdmModuleViewDetailEntity();
    //        mdmModuleViewDetailEntity.setMdmId(entity.getId());
    //        mdmModuleViewDetailEntity.setViewId(moduleViewEntityList.get(0).getId());
    //        mdmModuleViewDetailEntity.setSts("Y");
    //        List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntityList = mdmModuleViewDetailDao.queryBase(mdmModuleViewDetailEntity);
    //        setDbFiledType(mdmModuleViewVo, mdmModuleViewDetailEntityList);
    //    } else {
    //        mdmModuleViewVo.setMdmModuleViewEntity(new MdmModuleViewEntity());
    //        mdmModuleViewVo.setDbAddFiled(new ArrayList<>());
    //        mdmModuleViewVo.setDbEditFiled(new ArrayList<>());
    //        mdmModuleViewVo.setDbShowFiled(new ArrayList<>());
    //        mdmModuleViewVo.setDbQueryFiled(new ArrayList<>());
    //        mdmModuleViewVo.setDbListFiled(new ArrayList<>());
    //    }
    //    return BaseResult.getSuccessMessageEntity("查询视图成功", mdmModuleViewVo);
    //}
    //
    //private void setDbFiledType(MdmModuleViewVo mdmModuleViewVo, List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntityList) {
    //    //新增
    //    List<MdmModuleViewDetailEntity> addFiled = new ArrayList<>();
    //    //修改
    //    List<MdmModuleViewDetailEntity> editFiled = new ArrayList<>();
    //    //查看
    //    List<MdmModuleViewDetailEntity> showFiled = new ArrayList<>();
    //    //查询
    //    List<MdmModuleViewDetailEntity> queryFiled = new ArrayList<>();
    //    //列表
    //    List<MdmModuleViewDetailEntity> listFiled = new ArrayList<>();
    //    if (mdmModuleViewDetailEntityList != null && mdmModuleViewDetailEntityList.size() > 0) {
    //        for (int i = 0; i < mdmModuleViewDetailEntityList.size(); i++) {
    //            switch (mdmModuleViewDetailEntityList.get(i).getViewType()) {
    //                //1、查询2、列表3、新增4、修改 5、查看
    //                case "1":
    //                    queryFiled.add(mdmModuleViewDetailEntityList.get(i));
    //                    break;
    //                case "2":
    //                    listFiled.add(mdmModuleViewDetailEntityList.get(i));
    //                    break;
    //                case "3":
    //                    addFiled.add(mdmModuleViewDetailEntityList.get(i));
    //                    break;
    //                case "4":
    //                    editFiled.add(mdmModuleViewDetailEntityList.get(i));
    //                    break;
    //                case "5":
    //                    showFiled.add(mdmModuleViewDetailEntityList.get(i));
    //                    break;
    //                default:
    //            }
    //        }
    //    }
    //    mdmModuleViewVo.setDbAddFiled(addFiled);
    //    mdmModuleViewVo.setDbEditFiled(editFiled);
    //    mdmModuleViewVo.setDbShowFiled(showFiled);
    //    mdmModuleViewVo.setDbQueryFiled(queryFiled);
    //    mdmModuleViewVo.setDbListFiled(listFiled);
    //}
    //
    ///**
    // * @param mdmModuleViewVo
    // * @param mdmModuleDbEntityList
    // * @param mdmModuleDbFiledsEntityList
    // * @return void
    // * @Author lvleigang
    // * @Description 设置对应的字段类型
    // * @Date 2023/10/25
    // **/
    //private void setFiledType(MdmModuleViewVo mdmModuleViewVo, List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList) {
    //    //新增
    //    List<MdmDbFiledVo> addFiled = new ArrayList<>();
    //    //修改
    //    List<MdmDbFiledVo> editFiled = new ArrayList<>();
    //    //查看
    //    List<MdmDbFiledVo> showFiled = new ArrayList<>();
    //    //查询
    //    List<MdmDbFiledVo> queryFiled = new ArrayList<>();
    //    //列表
    //    List<MdmDbFiledVo> listFiled = new ArrayList<>();
    //    if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
    //        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
    //            if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
    //                for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
    //                    if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
    //                        if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
    //                            //1、主表
    //                            addFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
    //                            editFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
    //                            showFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
    //                            queryFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
    //                            listFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
    //                        } else {
    //                            //2、明细
    //                            queryFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
    //                            addFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
    //                            editFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
    //                            showFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
    //                        }
    //                    }
    //                }
    //            }
    //        }
    //    }
    //    mdmModuleViewVo.setAddFiled(addFiled);
    //    mdmModuleViewVo.setEditFiled(editFiled);
    //    mdmModuleViewVo.setShowFiled(showFiled);
    //    mdmModuleViewVo.setQueryFiled(queryFiled);
    //    mdmModuleViewVo.setListFiled(listFiled);
    //}
    //
    //

    //
    /**
     * @param mdmDbFiledVoList
     * @param type
     * @return void
     * @Author lvleigang
     * @Description 保存数据
     * @Date 1:37 下午 2023/10/25
     **/
    private void saveDbViewFiled(String mdmID, String viewid, List<MdmDbFiledVo> mdmDbFiledVoList, String type,List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntities) {
        if (mdmDbFiledVoList != null && mdmDbFiledVoList.size() > 0) {
            for (int i = 0; i < mdmDbFiledVoList.size(); i++) {
                MdmModuleViewDetailEntity mdmModuleViewDetailEntity = new MdmModuleViewDetailEntity();
                mdmModuleViewDetailEntity.setCreate();
                mdmModuleViewDetailEntity.setMdmId(mdmID);
                mdmModuleViewDetailEntity.setViewId(viewid);
                mdmModuleViewDetailEntity.setViewFiled(mdmDbFiledVoList.get(i).getId());
                mdmModuleViewDetailEntity.setViewType(type);
                mdmModuleViewDetailEntity.setDataType("1");
                mdmModuleViewDetailEntities.add(mdmModuleViewDetailEntity);
            }
        }
    }
    //
    ///**
    // * @param object
    // * @return com.hzya.frame.web.entity.JsonResultEntity
    // * @Author lvleigang
    // * @Description 主数据设置查询权限配置
    // * @Date 9:40 上午 2023/10/18
    // **/
    //@Override
    //public JsonResultEntity queryMdmModuleRule(JSONObject object) {
    //    MdmDto entity = getData("jsonStr", object, MdmDto.class);
    //    if (entity == null) {
    //        return BaseResult.getFailureMessageEntity("参数不允许为空");
    //    }
    //    if (entity.getId() == null || "".equals(entity.getId())) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    //查询模块下的角色列表
    //    MdmModuleRoleEntity mdmModuleRoleEntity = new MdmModuleRoleEntity();
    //    mdmModuleRoleEntity.setSts("Y");
    //    mdmModuleRoleEntity.setMdmId(entity.getId());
    //    List<MdmModuleRoleEntity> mdmModuleRoleEntities = mdmModuleRoleDao.queryBase(mdmModuleRoleEntity);
    //    if (mdmModuleRoleEntities != null && mdmModuleRoleEntities.size() > 0) {
    //        MdmModuleRoleButtonEntity mdmModuleRoleButtonEntity = new MdmModuleRoleButtonEntity();
    //        mdmModuleRoleButtonEntity.setSts("Y");
    //        mdmModuleRoleButtonEntity.setMdmId(entity.getId());
    //        List<MdmModuleRoleButtonEntity> mdmModuleRoleButtonEntities = mdmModuleRoleButtonDao.queryBase(mdmModuleRoleButtonEntity);
    //        if (mdmModuleRoleButtonEntities != null && mdmModuleRoleButtonEntities.size() > 0) {
    //            for (int i = 0; i < mdmModuleRoleEntities.size(); i++) {
    //                List<MdmModuleRoleButtonEntity> list = new ArrayList<>();
    //                for (int i1 = 0; i1 < mdmModuleRoleButtonEntities.size(); i1++) {
    //                    if (mdmModuleRoleEntities.get(i).getRoleId().equals(mdmModuleRoleButtonEntities.get(i1).getRoleId())) {
    //                        list.add(mdmModuleRoleButtonEntities.get(i1));
    //                    }
    //                }
    //                mdmModuleRoleEntities.get(i).setMdmModuleRoleButtonEntities(list);
    //            }
    //        }
    //    }
    //    return BaseResult.getSuccessMessageEntity("查询成功", mdmModuleRoleEntities);
    //}
    //
    ///**
    // * @param object
    // * @return com.hzya.frame.web.entity.JsonResultEntity
    // * @Author lvleigang
    // * @Description 主数据设置保存权限配置
    // * @Date 9:40 上午 2023/10/18
    // **/
    //@Override
    //public JsonResultEntity doSaveMdmModuleRule(JSONObject object) {
    //    MdmRoleDto entity = getData("jsonStr", object, MdmRoleDto.class);
    //    if (entity == null) {
    //        return BaseResult.getFailureMessageEntity("参数不允许为空");
    //    }
    //    if (entity.getId() == null || "".equals(entity.getId())) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    //查询菜单
    //    Module module = new Module();
    //    module.setFormId(entity.getId());
    //    List<Module> moduleList = moduleMapper.entity_list_base(module);
    //    if (moduleList != null && moduleList.size() == 1) {
    //        module = moduleList.get(0);
    //    } else {
    //        return BaseResult.getFailureMessageEntity("菜单错误请检查菜单");
    //    }
    //    //先删除
    //    RoleModule roleModule = new RoleModule();
    //    roleModule.setSts("Y");
    //    roleModule.setUpdate();
    //    roleModule.setModuleId(module.getId());
    //    roleModuleMapper.entity_logicDelete_Multi_Condition(roleModule);
    //    MdmModuleRoleEntity mdmModuleRoleEntity = new MdmModuleRoleEntity();
    //    mdmModuleRoleEntity.setMdmId(entity.getId());
    //    mdmModuleRoleEntity.setSts("Y");
    //    mdmModuleRoleEntity.setModify_user_id(StpUtil.getLoginIdAsString());
    //    mdmModuleRoleEntity.setModify_time(new Date());
    //    mdmModuleRoleDao.logicRemoveMultiCondition(mdmModuleRoleEntity);
    //    MdmModuleRoleButtonEntity mdmModuleRoleButtonEntity = new MdmModuleRoleButtonEntity();
    //    mdmModuleRoleButtonEntity.setMdmId(entity.getId());
    //    mdmModuleRoleButtonEntity.setSts("Y");
    //    mdmModuleRoleButtonEntity.setModify_user_id(StpUtil.getLoginIdAsString());
    //    mdmModuleRoleButtonEntity.setModify_time(new Date());
    //    mdmModuleRoleButtonDao.logicRemoveMultiCondition(mdmModuleRoleButtonEntity);
    //
    //    if (entity.getMdmModuleRoleEntities() != null && entity.getMdmModuleRoleEntities().size() > 0) {
    //        for (int i = 0; i < entity.getMdmModuleRoleEntities().size(); i++) {
    //
    //            MdmModuleRoleEntity moduleRoleEntity = entity.getMdmModuleRoleEntities().get(i);
    //            moduleRoleEntity.setMdmId(entity.getId());
    //            moduleRoleEntity.setSts("Y");
    //            moduleRoleEntity.setModify_user_id(StpUtil.getLoginIdAsString());
    //            moduleRoleEntity.setModify_time(new Date());
    //            if (moduleRoleEntity.getId() != null && !"".equals(moduleRoleEntity.getId())) {
    //                //修改
    //                mdmModuleRoleDao.update(moduleRoleEntity);
    //            } else {
    //                //新增
    //                moduleRoleEntity.setId(UUIDUtils.getUUID());
    //                moduleRoleEntity.setCreate_user_id(StpUtil.getLoginIdAsString());
    //                moduleRoleEntity.setCreate_time(new Date());
    //                mdmModuleRoleDao.save(moduleRoleEntity);
    //            }
    //            if (moduleRoleEntity.getMdmModuleRoleButtonEntities() != null && moduleRoleEntity.getMdmModuleRoleButtonEntities().size() > 0) {
    //                for (int i1 = 0; i1 < moduleRoleEntity.getMdmModuleRoleButtonEntities().size(); i1++) {
    //                    MdmModuleRoleButtonEntity moduleRoleButtonEntity = moduleRoleEntity.getMdmModuleRoleButtonEntities().get(i1);
    //                    moduleRoleButtonEntity.setMdmId(entity.getId());
    //                    moduleRoleButtonEntity.setSts("Y");
    //                    moduleRoleButtonEntity.setModify_user_id(StpUtil.getLoginIdAsString());
    //                    moduleRoleButtonEntity.setModify_time(new Date());
    //                    moduleRoleButtonEntity.setModuleRoleId(moduleRoleEntity.getRoleId());
    //                    moduleRoleButtonEntity.setRoleId(moduleRoleEntity.getRoleId());
    //                    if (moduleRoleButtonEntity.getId() != null && !"".equals(moduleRoleButtonEntity.getId())) {
    //                        //修改
    //                        mdmModuleRoleButtonDao.update(moduleRoleButtonEntity);
    //                    } else {
    //                        //新增
    //                        moduleRoleButtonEntity.setId(UUIDUtils.getUUID());
    //                        moduleRoleButtonEntity.setCreate_user_id(StpUtil.getLoginIdAsString());
    //                        moduleRoleButtonEntity.setCreate_time(new Date());
    //                        mdmModuleRoleButtonDao.save(moduleRoleButtonEntity);
    //                    }
    //                }
    //            }
    //            //再添加
    //            RoleModule saveRole = new RoleModule();
    //            saveRole.setCreate();
    //            saveRole.setRoleId(moduleRoleEntity.getRoleId());
    //            saveRole.setModuleId(module.getId());
    //            roleModuleMapper.entity_insert(saveRole);
    //        }
    //    }
    //    return BaseResult.getSuccessMessageEntity("保存成功");
    //}
    //

    //

    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据列表显示 树、查询条件、列表字段、按钮
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShow(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询模版
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }

        //设置模版
        MdmViewVo mdmViewVo = new MdmViewVo();
        mdmViewVo.setMdmModuleEntity(mdmModuleEntity);
        //查询展示类型
        MdmModuleViewEntity mdmModuleViewEntity = new MdmModuleViewEntity();
        mdmModuleViewEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleViewEntity.setSts("Y");
        List<MdmModuleViewEntity> moduleViewEntityList = mdmServiceCache.queryMdmModuleView(mdmModuleViewEntity);
        if (moduleViewEntityList == null || moduleViewEntityList.size() != 1) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        mdmModuleViewEntity = moduleViewEntityList.get(0);
        mdmViewVo.setMdmModuleViewEntity(mdmModuleViewEntity);

        //查询数据源主表
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源表下面的字段
        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
        mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbFiledsEntity.setSts("Y");
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity);
        if (mdmModuleDbFiledsEntityList == null || mdmModuleDbFiledsEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询字段下的规则
        MdmModuleDbFiledsRuleEntity mdmModuleDbFiledsRuleEntity = new MdmModuleDbFiledsRuleEntity();
        mdmModuleDbFiledsRuleEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbFiledsRuleEntity.setSts("Y");
        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList = mdmServiceCache.queryMdmModuleDbFiledsRule(mdmModuleDbFiledsRuleEntity);
        if (mdmModuleDbFiledsRuleEntityList == null || mdmModuleDbFiledsRuleEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }

        //查询设置的查询字段
        MdmModuleViewDetailEntity mdmModuleViewDetailEntity = new MdmModuleViewDetailEntity();
        mdmModuleViewDetailEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleViewDetailEntity.setSts("Y");
        List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntities = mdmServiceCache.queryMdmModuleViewDetail(mdmModuleViewDetailEntity);
        if (mdmModuleViewDetailEntities == null || mdmModuleViewDetailEntities.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        List<MdmViewFiledVo> queryList = getFiledByType("1",mdmModuleViewDetailEntities,mdmModuleDbEntityList,mdmModuleDbFiledsEntityList,mdmModuleDbFiledsRuleEntityList);
        mdmViewVo.setQueryList(queryList);
        List<MdmViewFiledVo> listList = getFiledByType("2",mdmModuleViewDetailEntities,mdmModuleDbEntityList,mdmModuleDbFiledsEntityList,mdmModuleDbFiledsRuleEntityList);
        mdmViewVo.setListList(listList);
        return BaseResult.getSuccessMessageEntity("获取字段成功", mdmViewVo);
    }

    /**
     * @Author lvleigang
     * @Description  根据类型获取字段
     * @Date 9:18 上午 2024/6/6
     * @param viewType 类型
     * @param mdmModuleViewDetailEntities 显示设置的字段
     * @param mdmModuleDbEntityList 表
     * @param mdmModuleDbFiledsEntityList 表字段
     * @param mdmModuleDbFiledsRuleEntityList 字段规则
     * @return java.util.List<com.hzya.frame.mdm.entity.MdmViewFiledVo>
     **/
    private List<MdmViewFiledVo> getFiledByType(String viewType, List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntities, List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList, List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList) {
        List<MdmViewFiledVo> mdmViewFiledVos = new ArrayList<>();
        if(mdmModuleViewDetailEntities != null && mdmModuleViewDetailEntities.size() > 0){
            for (int i = 0; i < mdmModuleViewDetailEntities.size(); i++) {
                if(viewType.equals(mdmModuleViewDetailEntities.get(i).getViewType())){
                    //类型一致
                    MdmViewFiledVo mdmViewFiledVo = new MdmViewFiledVo();
                    mdmViewFiledVo.setId(mdmModuleViewDetailEntities.get(i).getViewFiled());
                    for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                        if(mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleViewDetailEntities.get(i).getViewFiled())){
                            for (int i2 = 0; i2 < mdmModuleDbEntityList.size(); i2++) {
                                if(mdmModuleDbEntityList.get(i2).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())){
                                    mdmViewFiledVo.setDbName(mdmModuleDbEntityList.get(i2).getDbName());
                                    mdmViewFiledVo.setDbType(mdmModuleDbEntityList.get(i2).getDbType());
                                    mdmViewFiledVo.setMdmId(mdmModuleDbEntityList.get(i2).getMdmId());
                                    mdmViewFiledVo.setDbId(mdmModuleDbEntityList.get(i2).getId());

                                    break;
                                }
                            }
                            mdmViewFiledVo.setChName(mdmModuleDbFiledsEntityList.get(i1).getChName());
                            mdmViewFiledVo.setEnName(mdmModuleDbFiledsEntityList.get(i1).getEnName());
                            mdmViewFiledVo.setFiledType(mdmModuleDbFiledsEntityList.get(i1).getFiledType());
                            //字段规则
                            if(mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0){
                                List<MdmModuleDbFiledsRuleEntity> ruleList = new ArrayList<>();
                                for (int i2 = 0; i2 < mdmModuleDbFiledsRuleEntityList.size(); i2++) {
                                    if(mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getFiledId())){
                                        ruleList.add(mdmModuleDbFiledsRuleEntityList.get(i2));
                                    }
                                }
                                mdmViewFiledVo.setRuleList(ruleList);
                            }
                            break;
                        }
                    }
                }
            }
        }
        if(mdmViewFiledVos != null && mdmViewFiledVos.size() > 0){
            for (int i = 0; i < mdmViewFiledVos.size(); i++) {
                mdmViewFiledVos.get(i).setSorts(i);
            }
        }
        return mdmViewFiledVos;
    }
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据查询所有字段
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowAll(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询设置各种类型字段
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        //查询模版数据源
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        List<MdmDbFiledVo> listFiled = new ArrayList<>();
        if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
            MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
            mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntity.getId());
            mdmModuleDbFiledsEntity.setSts("Y");
            List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity);
            //
            if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
                for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                    if("1".equals(mdmModuleDbEntityList.get(i).getDbType()) || "2".equals(mdmModuleDbEntityList.get(i).getDbType())){
                        if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
                            for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                                if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
                                    if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                                        //1、主表
                                        listFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    } else {
                                        //2、明细
                                        listFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return BaseResult.getSuccessMessageEntity("查询视图成功", listFiled);
    }
    //
    ///**
    // * @param mdmModuleRoleButtonEntities
    // * @return java.util.List<com.hzya.frame.mdm.entity.MdmViewButtonVo>
    // * @Author lvleigang
    // * @Description 设置返回按钮
    // * @Date 4:48 下午 2023/10/26
    // **/
    //private List<MdmViewButtonVo> setButton(List<MdmModuleRoleButtonEntity> mdmModuleRoleButtonEntities) {
    //    List<MdmViewButtonVo> mdmViewButtonVoList = new ArrayList<>();
    //    if (mdmModuleRoleButtonEntities != null && mdmModuleRoleButtonEntities.size() > 0) {
    //        for (int i = 0; i < mdmModuleRoleButtonEntities.size(); i++) {
    //            mdmViewButtonVoList.add(new MdmViewButtonVo(mdmModuleRoleButtonEntities.get(i).getButtonType(), mdmModuleRoleButtonEntities.get(i).getButtonName()));
    //        }
    //    }
    //    return mdmViewButtonVoList;
    //}
    //
    ///**
    // * @param allRecords
    // * @param checkedMeters
    // * @return java.util.List<com.hzya.frame.mdm.mdmModuleViewDetail.entity.MdmModuleViewDetailEntity>
    // * @Author lvleigang
    // * @Description 取出重复字段数据
    // * @Date 4:34 下午 2023/10/26
    // **/
    //private List<MdmModuleViewDetailEntity> getDolist(List<MdmModuleViewDetailEntity> allRecords, List<MdmModuleUserViewEntity> checkedMeters) {
    //    List<MdmModuleViewDetailEntity> meterPlan = allRecords.stream()
    //            .filter(item -> checkedMeters.stream()
    //                    .map(e -> {
    //                        if (!Objects.equals(item.getViewFiled(), e.getViewDetailId())) {
    //                            return null;
    //                        } else {
    //                            return item.getViewFiled();
    //                        }
    //                    })
    //                    .collect(Collectors.toList())
    //                    .contains(item.getViewFiled()))
    //            .collect(Collectors.toList());
    //    return meterPlan;
    //}
    //
    ///**
    // * @param mdmModuleDbEntityList           数据源
    // * @param mdmModuleDbFiledsEntityList     数据源下的字段表
    // * @param mdmModuleDbFiledsRuleEntityList 数据源字段的规则表
    // * @param queryList                       需要的字段
    // * @return java.util.List<com.hzya.frame.mdm.entity.MdmViewFiledVo>
    // * @Author lvleigang
    // * @Description 根据字段设置返回前台字段
    // * @Date 4:11 下午 2023/10/26
    // **/
    //private List<MdmViewFiledVo> setQueryList(List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList, List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList, List<MdmModuleViewDetailEntity> queryList, boolean flag) {
    //    List<MdmViewFiledVo> mdmViewFiledVos = new ArrayList<>();
    //
    //    if (queryList != null && queryList.size() > 0) {
    //        for (int i = 0; i < queryList.size(); i++) {
    //            MdmViewFiledVo mdmViewFiledVo = new MdmViewFiledVo();
    //            mdmViewFiledVo.setId(queryList.get(i).getViewFiled());//字段id
    //            mdmViewFiledVo.setSorts(i + 2);//排序
    //            for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
    //                if (queryList.get(i).getViewFiled().equals(mdmModuleDbFiledsEntityList.get(i1).getId())) {
    //                    mdmViewFiledVo.setFiledType(mdmModuleDbFiledsEntityList.get(i1).getFiledType());//英文名
    //                    mdmViewFiledVo.setEnName(mdmModuleDbFiledsEntityList.get(i1).getEnName());//英文名
    //                    mdmViewFiledVo.setChName(mdmModuleDbFiledsEntityList.get(i1).getChName());//中文名
    //                    for (int i2 = 0; i2 < mdmModuleDbEntityList.size(); i2++) {
    //                        if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i2).getId())) {
    //                            mdmViewFiledVo.setDbType(mdmModuleDbEntityList.get(i2).getDbType());//类型 1、主表 2、明细
    //                            mdmViewFiledVo.setMdmId(mdmModuleDbEntityList.get(i2).getMdmId());//主数据模版ID
    //                            mdmViewFiledVo.setDbId(mdmModuleDbEntityList.get(i2).getId());//模版数据库id
    //                            mdmViewFiledVo.setDbName(mdmModuleDbEntityList.get(i2).getDbName());//表名
    //
    //                            break;
    //                        }
    //                    }
    //                    break;
    //                }
    //            }
    //            //设置字段规则
    //            List<MdmModuleDbFiledsRuleEntity> ruleList = new ArrayList<>();
    //            if (mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0) {
    //                for (int i1 = 0; i1 < mdmModuleDbFiledsRuleEntityList.size(); i1++) {
    //                    if (queryList.get(i).getViewFiled().equals(mdmModuleDbFiledsRuleEntityList.get(i1).getFiledId())) {
    //                        ruleList.add(mdmModuleDbFiledsRuleEntityList.get(i1));
    //                    }
    //                }
    //            }
    //            mdmViewFiledVo.setRuleList(ruleList);
    //            mdmViewFiledVos.add(mdmViewFiledVo);
    //        }
    //    }
    //    MdmViewFiledVo mdmViewFiledVo = new MdmViewFiledVo();
    //    mdmViewFiledVo.setSorts(1);//排序
    //    mdmViewFiledVo.setFiledType("3");
    //    mdmViewFiledVo.setEnName("document_rule");//英文名
    //    mdmViewFiledVo.setChName("单据编码");//中文名
    //    mdmViewFiledVo.setDbType("1");//类型 1、主表 2、明细
    //    if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
    //        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
    //            if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
    //                mdmViewFiledVo.setDbName(mdmModuleDbEntityList.get(i).getDbName());//表名
    //            }
    //        }
    //    }
    //    List<MdmModuleDbFiledsRuleEntity> msgRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity msgRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    msgRuleTitie.setFormName("optionRuleForm");
    //    msgRuleTitie.setRuleCode("title");
    //    msgRuleTitie.setRuleName("显示名");
    //    msgRuleTitie.setRuleType("2");
    //    msgRuleTitie.setRuleValue("单据编码");
    //    MdmModuleDbFiledsRuleEntity msgRulerow = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerow.setFormName("optionRuleForm");
    //    msgRulerow.setRuleCode("row");
    //    msgRulerow.setRuleName("宽度");
    //    msgRulerow.setRuleType("2");
    //    msgRulerow.setRuleValue("12");
    //    MdmModuleDbFiledsRuleEntity msgRuletype = new MdmModuleDbFiledsRuleEntity();
    //    msgRuletype.setFormName("optionRuleForm");
    //    msgRuletype.setRuleCode("type");
    //    msgRuletype.setRuleName("数据类型");
    //    msgRuletype.setRuleType("2");
    //    msgRuletype.setRuleValue("input");
    //    MdmModuleDbFiledsRuleEntity msgRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerequired.setFormName("optionRuleForm");
    //    msgRulerequired.setRuleCode("required");
    //    msgRulerequired.setRuleName("必填");
    //    msgRulerequired.setRuleType("2");
    //    MdmModuleDbFiledsRuleEntity withs = new MdmModuleDbFiledsRuleEntity();
    //    withs.setFormName("optionRuleForm");
    //    withs.setRuleCode("width");
    //    withs.setRuleName("宽度");
    //    withs.setRuleType("2");
    //    withs.setRuleValue("200");
    //    msgRule.add(withs);
    //    msgRule.add(msgRulerequired);
    //    msgRule.add(msgRuletype);
    //    msgRule.add(msgRulerow);
    //    msgRule.add(msgRuleTitie);
    //    mdmViewFiledVo.setRuleList(msgRule);
    //    mdmViewFiledVos.add(0, mdmViewFiledVo);
    //
    //    //添加分发数量
    //    if (flag) {
    //        addFfsl(mdmModuleDbEntityList, mdmViewFiledVos);
    //    }
    //    return mdmViewFiledVos;
    //}
    //
    //private void addFfsl(List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmViewFiledVo> mdmViewFiledVos) {
    //
    //    MdmViewFiledVo mdmViewFiledVo = new MdmViewFiledVo();
    //    mdmViewFiledVo.setSorts(1);//排序
    //    mdmViewFiledVo.setFiledType("1");
    //    mdmViewFiledVo.setEnName("qwqwasdasdzxasda");//英文名
    //    mdmViewFiledVo.setChName("分发数量");//中文名
    //    mdmViewFiledVo.setDbType("1");//类型 1、主表 2、明细
    //    if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
    //        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
    //            if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
    //                mdmViewFiledVo.setDbName(mdmModuleDbEntityList.get(i).getDbName());//表名
    //            }
    //        }
    //    }
    //    List<MdmModuleDbFiledsRuleEntity> msgRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity msgRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    msgRuleTitie.setFormName("optionRuleForm");
    //    msgRuleTitie.setRuleCode("title");
    //    msgRuleTitie.setRuleName("显示名");
    //    msgRuleTitie.setRuleType("2");
    //    msgRuleTitie.setRuleValue("分发数量");
    //    MdmModuleDbFiledsRuleEntity msgRulerow = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerow.setFormName("optionRuleForm");
    //    msgRulerow.setRuleCode("row");
    //    msgRulerow.setRuleName("宽度");
    //    msgRulerow.setRuleType("2");
    //    msgRulerow.setRuleValue("6");
    //    MdmModuleDbFiledsRuleEntity msgRuletype = new MdmModuleDbFiledsRuleEntity();
    //    msgRuletype.setFormName("optionRuleForm");
    //    msgRuletype.setRuleCode("type");
    //    msgRuletype.setRuleName("数据类型");
    //    msgRuletype.setRuleType("2");
    //    msgRuletype.setRuleValue("input");
    //    MdmModuleDbFiledsRuleEntity msgRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerequired.setFormName("optionRuleForm");
    //    msgRulerequired.setRuleCode("required");
    //    msgRulerequired.setRuleName("必填");
    //    msgRulerequired.setRuleType("2");
    //    msgRule.add(msgRulerequired);
    //    msgRule.add(msgRuletype);
    //    msgRule.add(msgRulerow);
    //    msgRule.add(msgRuleTitie);
    //    mdmViewFiledVo.setRuleList(msgRule);
    //    mdmViewFiledVos.add(mdmViewFiledVo);
    //}
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据列表显示 业务数据
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowData(JSONObject object) {
        MdmQuery entity = getData("jsonStr", object, MdmQuery.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        //判断分页
        if (entity == null || entity.getPageNum() == null || entity.getPageSize() == null) {
            return BaseResult.getFailureMessageEntity("分页查询参数不存在");
        }
        PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
        List<HashMap<String, Object>> businessResult = mdmModuleDao.queryMdmShowData(entity);
        PageInfo pageInfo = new PageInfo(businessResult);
        return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
    }
    //
    ///**
    // * @param object
    // * @return com.hzya.frame.web.entity.JsonResultEntity
    // * @Author lvleigang
    // * @Description 主数据列表显示 业务数据
    // * @Date 9:40 上午 2023/10/18
    // **/
    //@Override
    //public JsonResultEntity queryMdmShowDistribute(JSONObject object) {
    //    MdmDto entity = getData("jsonStr", object, MdmDto.class);
    //    if (entity == null) {
    //        return BaseResult.getFailureMessageEntity("参数不允许为空");
    //    }
    //    if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    if (entity.getId() == null || "".equals(entity.getId())) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    //查询模版
    //    MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
    //    mdmModuleEntity.setMdmCode(entity.getMdmCode());
    //    mdmModuleEntity.setSts("Y");
    //    List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
    //    if (mdmModuleEntities == null || mdmModuleEntities.size() != 1) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //
    //    //查询数据源主表
    //    MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
    //    mdmModuleDbEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //    mdmModuleDbEntity.setDbType("1");
    //    mdmModuleDbEntity.setSts("Y");
    //    List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(mdmModuleDbEntity);
    //    if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    mdmModuleDbEntity = mdmModuleDbEntityList.get(0);
    //    Map<String, Object> queryData = new HashMap<>();
    //    queryData.put("tableName", mdmModuleDbEntity.getDbName() + "_distribute");//表名
    //    queryData.put("id", entity.getId());//字段
    //    List<MdmDistributeVo> datas = mdmModuleDbDao.getServiceByDistributeIdNoCase(queryData);
    //    List<MdmDistributeVo> returnData = new ArrayList<>();
    //
    //    //查询分发表
    //    MdmModuleDistributeEntity mdmModuleDistributeEntity = new MdmModuleDistributeEntity();
    //    mdmModuleDistributeEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //    mdmModuleDistributeEntity.setSts("Y");
    //    List<MdmModuleDistributeEntity> mdmModuleDistributeEntities = mdmModuleDistributeDao.queryBase(mdmModuleDistributeEntity);
    //    if (datas != null && datas.size() > 0) {
    //        if (mdmModuleDistributeEntities != null && mdmModuleDistributeEntities.size() > 0) {
    //            for (int i = 0; i < mdmModuleDistributeEntities.size(); i++) {
    //                boolean flag = false;
    //                for (int i1 = 0; i1 < datas.size(); i1++) {
    //                    if (datas.get(i1).getAppId().equals(mdmModuleDistributeEntities.get(i).getAppId())) {
    //                        flag = true;
    //                        break;
    //                    }
    //                }
    //                if (!flag) {
    //                    MdmDistributeVo mdmDistributeVo = new MdmDistributeVo();
    //                    mdmDistributeVo.setAppId(mdmModuleDistributeEntities.get(i).getAppId());
    //                    mdmDistributeVo.setStatus("4");
    //                    mdmDistributeVo.setMsg("未发送");
    //                    returnData.add(mdmDistributeVo);
    //                }
    //            }
    //        }
    //        returnData.addAll(datas);
    //    } else {
    //        if (mdmModuleDistributeEntities != null && mdmModuleDistributeEntities.size() > 0) {
    //            for (int i = 0; i < mdmModuleDistributeEntities.size(); i++) {
    //                MdmDistributeVo mdmDistributeVo = new MdmDistributeVo();
    //                mdmDistributeVo.setAppId(mdmModuleDistributeEntities.get(i).getAppId());
    //                mdmDistributeVo.setStatus("4");
    //                mdmDistributeVo.setMsg("未发送");
    //                returnData.add(mdmDistributeVo);
    //            }
    //        }
    //    }
    //    return BaseResult.getSuccessMessageEntity("查询数据成功", returnData);
    //}
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 查询数据（list 或者 分页）
     * @Date 1:33 下午 2023/7/12
     **/
    @Override
    public JsonResultEntity queryTemplateData(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        //校验是否有servecr传参
        if (!checkStr(entity.getTableName())) {
            return BaseResult.getFailureMessageEntity("请先传递服务名");
        }
        if (!checkStr(entity.getValue())) {
            return BaseResult.getFailureMessageEntity("请先传递存储字段");
        }
        if (!checkStr(entity.getLabel())) {
            return BaseResult.getFailureMessageEntity("请先传递显示字段");
        }
        if (entity.getPageNum() != null && entity.getPageSize() != null) {
            PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
            List<HashMap<String, Object>> mapList = mdmModuleDao.querySelectData(entity);
            PageInfo pageInfo = new PageInfo(mapList);
            return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
        } else {
            List<HashMap<String, Object>> mapList = mdmModuleDao.querySelectData(entity);
            return BaseResult.getSuccessMessageEntity("查询数据成功", mapList);
        }
    }
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 业务数据树形结构，数据查询
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowTreeData(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        //if (entity.getTableName() == null || "".equals(entity.getTableName())) {
        //    return BaseResult.getFailureMessageEntity("系统错误");
        //}
        if (entity.getLabel() == null || "".equals(entity.getLabel())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getUpId() == null || "".equals(entity.getUpId())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");

        }
        //查询模版
        MdmModuleEntity  mdmModuleEntities = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if (mdmModuleEntities == null ) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源主表
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
            if("1".equals(mdmModuleDbEntityList.get(i).getDbType())){
                mdmModuleDbEntity = mdmModuleDbEntityList.get(i);
                break;
            }
        }
        entity.setTableName(mdmModuleDbEntity.getDbName());



        if (checkStr(entity.getId())) {
            if (!checkStr(entity.getValue())) {
                return BaseResult.getFailureMessageEntity("请先传递存储字段");
            }
            if (entity.getId().contains(",")) {
                String[] strArray = entity.getId().split(",");  // 使用逗号和空格作为分隔符
                entity.setIds(strArray);
                List<HashMap<String, Object>> mapList = mdmModuleDao.queryTemplateDataMore(entity);
                if (mapList == null || mapList.size() == 0) {
                    List<HashMap<String, Object>> returnList = new ArrayList<>();
                    return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
                }
                List<HashMap<String, Object>> returnList = gettochilder(strArray, 0, mapList);
                return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
            } else {
                HashMap<String, Object> mapList = mdmModuleDao.queryTemplateDataOne(entity);
                if (mapList == null || mapList.size() == 0) {
                    List<HashMap<String, Object>> returnList = new ArrayList<>();
                    return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
                }
                List<HashMap<String, Object>> returnList = new ArrayList<>();
                returnList.add(mapList);
                return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
            }
        } else {
            List<HashMap<String, Object>> mapList = mdmModuleDao.queryDataAll(entity);
            List<HashMap<String, Object>> returnList = new ArrayList<>();

            if (mapList != null && mapList.size() > 0) {
                for (int i = 0; i < mapList.size(); i++) {
                    //默认为根
                    if (mapList.get(i).get(entity.getUpId()) == null || "".equals(mapList.get(i).get(entity.getUpId()))) {
                        List<HashMap<String, Object>> children = getchilder(mapList.get(i).get("qsdfg").toString(), mapList, entity);
                        HashMap<String, Object> re = new HashMap<>();
                        re.put("id", mapList.get(i).get("qsdfg"));
                        re.put("label", mapList.get(i).get(entity.getLabel()));
                        re.put("upID", mapList.get(i).get(entity.getUpId()));
                        if (children != null && children.size() > 0) {
                            re.put("children", children);
                        }
                        returnList.add(re);
                    }
                }
            }
            return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
        }
    }
    //
    private List<HashMap<String, Object>> gettochilder(String[] strArray, int i, List<HashMap<String, Object>> mapList) {
        List<HashMap<String, Object>> maps = new ArrayList<>();
        for (int i1 = 0; i1 < mapList.size(); i1++) {
            if (strArray[i].equals(mapList.get(i1).get("id").toString())) {
                if (strArray.length >= (i + 2)) {
                    mapList.get(i1).put("children", gettochilder(strArray, i + 1, mapList));
                }
                maps.add(mapList.get(i1));
                break;
            }
        }
        return maps;
    }
    //
    //private HashMap<String, Object> getFathers(List<HashMap<String, Object>> mapListAll, HashMap<String, Object> mapList, MdmDto entity) {
    //    if (mapList.get("upID") == null) {
    //        return mapList;
    //    }
    //    HashMap<String, Object> retList = new HashMap<>();
    //    if (mapListAll != null && mapListAll.size() > 0) {
    //        for (int i = 0; i < mapListAll.size(); i++) {
    //            //等于上级id的时候
    //            if (mapListAll.get(i).get("qsdfg").equals(mapList.get("upID"))) {
    //                retList.put("id", mapListAll.get(i).get("qsdfg"));
    //                retList.put("label", mapListAll.get(i).get(entity.getLabel()));
    //                retList.put("upID", mapListAll.get(i).get(entity.getUpId()));
    //                List<HashMap<String, Object>> returnList = new ArrayList<>();
    //                returnList.add(mapList);
    //                retList.put("children", returnList);
    //                break;
    //            }
    //        }
    //    }
    //    HashMap<String, Object> a = getFathers(mapListAll, retList, entity);
    //    return a;
    //}
    //
    private List<HashMap<String, Object>> getchilder(String stringObjectHashMap, List<HashMap<String, Object>> mapList, MdmDto entity) {
        List<HashMap<String, Object>> returnList = new ArrayList<>();
        if (mapList != null && mapList.size() > 0) {
            for (int i = 0; i < mapList.size(); i++) {
                //等于上级id的时候
                if (stringObjectHashMap.equals(mapList.get(i).get(entity.getUpId()))) {
                    List<HashMap<String, Object>> children = getchilder(mapList.get(i).get(entity.getUpId()) + "," + mapList.get(i).get("qsdfg"), mapList, entity);
                    HashMap<String, Object> re = new HashMap<>();
                    re.put("id", mapList.get(i).get("qsdfg"));
                    re.put("label", mapList.get(i).get(entity.getLabel()));
                    re.put("upID", mapList.get(i).get(entity.getUpId()));
                    if (children != null && children.size() > 0) {
                        re.put("children", children);
                    }
                    returnList.add(re);
                }
            }
        }
        return returnList;
    }
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情 区分类型 新增、修改、查看
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowDetails(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getShowType() == null || "".equals(entity.getShowType())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询模版
        //List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
        MdmModuleEntity mdmModuleEntities = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if (mdmModuleEntities == null) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmDetailViewVo mdmViewVo = new MdmDetailViewVo();
        mdmViewVo.setMdmModuleEntity(mdmModuleEntities);

        //查询数据源主表
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源表下面的字段
        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
        mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleDbFiledsEntity.setSts("Y");
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity);
        if (mdmModuleDbFiledsEntityList == null || mdmModuleDbFiledsEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询字段下的规则
        MdmModuleDbFiledsRuleEntity mdmModuleDbFiledsRuleEntity = new MdmModuleDbFiledsRuleEntity();
        mdmModuleDbFiledsRuleEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleDbFiledsRuleEntity.setSts("Y");
        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList = mdmServiceCache.queryMdmModuleDbFiledsRule(mdmModuleDbFiledsRuleEntity);
        if (mdmModuleDbFiledsRuleEntityList == null || mdmModuleDbFiledsRuleEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleViewDetailEntity mdmModuleViewDetailEntity = new MdmModuleViewDetailEntity();
        mdmModuleViewDetailEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleViewDetailEntity.setSts("Y");
        mdmModuleViewDetailEntity.setViewType(entity.getShowType());//设置显示字段类型
        List<MdmModuleViewDetailEntity> queryAll = mdmModuleViewDetailDao.queryBase(mdmModuleViewDetailEntity);
        List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntityList = new ArrayList<>();
        if(queryAll != null && queryAll.size() > 0){
            for (int i = 0; i < queryAll.size(); i++) {
                if(entity.getShowType().equals(queryAll.get(i).getViewType())){
                    mdmModuleViewDetailEntityList.add(queryAll.get(i));
                }
            }
        }
        //组装数据
        assembleMdmShowDetails(mdmViewVo, mdmModuleDbEntityList, mdmModuleDbFiledsEntityList, mdmModuleDbFiledsRuleEntityList, mdmModuleViewDetailEntityList, entity.getShowType());
        return BaseResult.getSuccessMessageEntity("获取字段成功", mdmViewVo);
    }

    /**
     * @param mdmViewVo                       返回对象
     * @param mdmModuleDbEntityList           数据源表
     * @param mdmModuleDbFiledsEntityList     数据源字段
     * @param mdmModuleDbFiledsRuleEntityList 数据源字段规则
     * @param mdmModuleViewDetailEntityList   数据源显示字段
     * @return void
     * @Author lvleigang
     * @Description 组装显示字段
     * @Date 9:10 上午 2023/11/6
     **/
    private void assembleMdmShowDetails(MdmDetailViewVo mdmViewVo, List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList, List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList, List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntityList, String showType) {
        //主数据主表
        MdmModuleDbEntity mainMdmModuleDb = new MdmModuleDbEntity();
        List<MdmModuleDbFiledsEntity> mainMdmModuleDbFileds = new ArrayList<>();
        //主数据子表
        List<MdmModuleDbEntity> sublistMdmModuleDb = new ArrayList<>();

        if (mdmModuleViewDetailEntityList != null && mdmModuleViewDetailEntityList.size() > 0) {
            //先循环数据源表，设置出数据字段
            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    //1、主表 2、明细
                    mainMdmModuleDb = mdmModuleDbEntityList.get(i);
                    //循环字段表
                    if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
                        for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                            if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
                                for (int b = 0; b < mdmModuleViewDetailEntityList.size(); b++) {
                                    if (mdmModuleViewDetailEntityList.get(b).getViewFiled().equals(mdmModuleDbFiledsEntityList.get(i1).getId())) {
                                        mainMdmModuleDbFileds.add(mdmModuleDbFiledsEntityList.get(i1));
                                        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRules = new ArrayList<>();
                                        //循环字段属性
                                        if (mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0) {
                                            for (int i2 = 0; i2 < mdmModuleDbFiledsRuleEntityList.size(); i2++) {
                                                if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getDbId())
                                                        && mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getFiledId())) {
                                                    mdmModuleDbFiledsRules.add(mdmModuleDbFiledsRuleEntityList.get(i2));
                                                }
                                            }
                                        }
                                        mdmModuleDbFiledsEntityList.get(i1).setMdmModuleDbFiledsRules(mdmModuleDbFiledsRules);
                                    }
                                }
                            }
                        }
                    }
                } else if ("2".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    //2、明细
                    sublistMdmModuleDb.add(mdmModuleDbEntityList.get(i));
                    //循环字段表
                    if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
                        List<MdmModuleDbFiledsEntity> sublistMdmModuleDbFileds = new ArrayList<>();
                        for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                            if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
                                for (int b = 0; b < mdmModuleViewDetailEntityList.size(); b++) {
                                    if (mdmModuleViewDetailEntityList.get(b).getViewFiled().equals(mdmModuleDbFiledsEntityList.get(i1).getId())) {
                                        sublistMdmModuleDbFileds.add(mdmModuleDbFiledsEntityList.get(i1));
                                        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRules = new ArrayList<>();
                                        //循环字段属性
                                        if (mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0) {
                                            for (int i2 = 0; i2 < mdmModuleDbFiledsRuleEntityList.size(); i2++) {
                                                if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getDbId())
                                                        && mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getFiledId())) {
                                                    mdmModuleDbFiledsRules.add(mdmModuleDbFiledsRuleEntityList.get(i2));
                                                }
                                            }
                                        }
                                        mdmModuleDbFiledsEntityList.get(i1).setMdmModuleDbFiledsRules(mdmModuleDbFiledsRules);
                                    }
                                }

                            }
                        }
                        mdmModuleDbEntityList.get(i).setSublistMdmModuleDbFileds(sublistMdmModuleDbFileds);
                    }
                }
            }
            mainMdmModuleDb.setSublistMdmModuleDbFileds(mainMdmModuleDbFileds);
            mdmViewVo.setMainMdmModuleDb(mainMdmModuleDb);
            //主数据子表
            List<MdmModuleDbEntity> mdmModuleDb = new ArrayList<>();
            if (sublistMdmModuleDb != null && sublistMdmModuleDb.size() > 0) {
                for (int i = 0; i < sublistMdmModuleDb.size(); i++) {
                    if (sublistMdmModuleDb.get(i).getSublistMdmModuleDbFileds() != null && sublistMdmModuleDb.get(i).getSublistMdmModuleDbFileds().size() > 0) {
                        mdmModuleDb.add(sublistMdmModuleDb.get(i));
                    }
                }
            }
            //if ("5".equals(showType)) {
            //    MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
            //    mdmModuleDbEntity.setDbName(mainMdmModuleDb.getDbName() + "_distribute");
            //    mdmModuleDbEntity.setRemark(mainMdmModuleDb.getRemark() + "分发表");
            //    mdmModuleDbEntity.setDbType("2");
            //    List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList1 = getDistributeRole();
            //    mdmModuleDbEntity.setSublistMdmModuleDbFileds(mdmModuleDbFiledsEntityList1);
            //    mdmModuleDb.add(mdmModuleDbEntity);
            //}
            mdmViewVo.setSublistMdmModuleDb(mdmModuleDb);

        } else {
            mdmViewVo.setMainMdmModuleDb(mainMdmModuleDb);
            mdmViewVo.setSublistMdmModuleDb(sublistMdmModuleDb);
        }
    }
    //
    //private List<MdmModuleDbFiledsEntity> getDistributeRole() {
    //    List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = new ArrayList<>();
    //    //app
    //    MdmModuleDbFiledsEntity appFiled = new MdmModuleDbFiledsEntity();
    //    appFiled.setChName("应用");
    //    appFiled.setEnName("app_id");
    //    appFiled.setFiledLength("50");
    //    appFiled.setFiledType("3");
    //    List<MdmModuleDbFiledsRuleEntity> appRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity appRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    appRuleTitie.setFormName("optionRuleForm");
    //    appRuleTitie.setRuleCode("title");
    //    appRuleTitie.setRuleName("显示名");
    //    appRuleTitie.setRuleType("2");
    //    appRuleTitie.setRuleValue("应用");
    //    MdmModuleDbFiledsRuleEntity appRulerow = new MdmModuleDbFiledsRuleEntity();
    //    appRulerow.setFormName("optionRuleForm");
    //    appRulerow.setRuleCode("row");
    //    appRulerow.setRuleName("宽度");
    //    appRulerow.setRuleType("2");
    //    appRulerow.setRuleValue("6");
    //    MdmModuleDbFiledsRuleEntity appRuletype = new MdmModuleDbFiledsRuleEntity();
    //    appRuletype.setFormName("optionRuleForm");
    //    appRuletype.setRuleCode("type");
    //    appRuletype.setRuleName("数据类型");
    //    appRuletype.setRuleType("2");
    //    appRuletype.setRuleValue("select");
    //    MdmModuleDbFiledsRuleEntity appRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    appRulerequired.setFormName("optionRuleForm");
    //    appRulerequired.setRuleCode("required");
    //    appRulerequired.setRuleName("必填");
    //    appRulerequired.setRuleType("2");
    //    MdmModuleDbFiledsRuleEntity appRuleservice = new MdmModuleDbFiledsRuleEntity();
    //    appRuleservice.setFormName("typeOptionRuleForm");
    //    appRuleservice.setRuleCode("service");
    //    appRuleservice.setRuleName("服务名称");
    //    appRuleservice.setRuleType("2");
    //    appRuleservice.setRuleValue("sys_application");
    //    MdmModuleDbFiledsRuleEntity appRulelabel = new MdmModuleDbFiledsRuleEntity();
    //    appRulelabel.setFormName("typeOptionRuleForm");
    //    appRulelabel.setRuleCode("label");
    //    appRulelabel.setRuleName("label");
    //    appRulelabel.setRuleType("2");
    //    appRulelabel.setRuleValue("name");
    //    MdmModuleDbFiledsRuleEntity appRulevalue = new MdmModuleDbFiledsRuleEntity();
    //    appRulevalue.setFormName("typeOptionRuleForm");
    //    appRulevalue.setRuleCode("value");
    //    appRulevalue.setRuleName("value");
    //    appRulevalue.setRuleType("2");
    //    appRulevalue.setRuleValue("id");
    //    appRule.add(appRulevalue);
    //    appRule.add(appRulelabel);
    //    appRule.add(appRuleservice);
    //    appRule.add(appRulerequired);
    //    appRule.add(appRuletype);
    //    appRule.add(appRulerow);
    //    appRule.add(appRuleTitie);
    //    appFiled.setMdmModuleDbFiledsRules(appRule);
    //    mdmModuleDbFiledsEntityList.add(appFiled);
    //
    //
    //    //status
    //    MdmModuleDbFiledsEntity statusFiled = new MdmModuleDbFiledsEntity();
    //    statusFiled.setChName("状态");
    //    statusFiled.setEnName("status");
    //    statusFiled.setFiledLength("50");
    //    statusFiled.setFiledType("3");
    //    List<MdmModuleDbFiledsRuleEntity> statusRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity statusRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    statusRuleTitie.setFormName("optionRuleForm");
    //    statusRuleTitie.setRuleCode("title");
    //    statusRuleTitie.setRuleName("显示名");
    //    statusRuleTitie.setRuleType("2");
    //    statusRuleTitie.setRuleValue("状态");
    //    MdmModuleDbFiledsRuleEntity statusRulerow = new MdmModuleDbFiledsRuleEntity();
    //    statusRulerow.setFormName("optionRuleForm");
    //    statusRulerow.setRuleCode("row");
    //    statusRulerow.setRuleName("宽度");
    //    statusRulerow.setRuleType("2");
    //    statusRulerow.setRuleValue("6");
    //    MdmModuleDbFiledsRuleEntity statusRuletype = new MdmModuleDbFiledsRuleEntity();
    //    statusRuletype.setFormName("optionRuleForm");
    //    statusRuletype.setRuleCode("type");
    //    statusRuletype.setRuleName("数据类型");
    //    statusRuletype.setRuleType("2");
    //    statusRuletype.setRuleValue("input");
    //    MdmModuleDbFiledsRuleEntity statusRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    statusRulerequired.setFormName("optionRuleForm");
    //    statusRulerequired.setRuleCode("required");
    //    statusRulerequired.setRuleName("必填");
    //    statusRulerequired.setRuleType("2");
    //    statusRule.add(statusRulerequired);
    //    statusRule.add(statusRuletype);
    //    statusRule.add(statusRulerow);
    //    statusRule.add(statusRuleTitie);
    //    statusFiled.setMdmModuleDbFiledsRules(statusRule);
    //    mdmModuleDbFiledsEntityList.add(statusFiled);
    //
    //
    //    //msg
    //    MdmModuleDbFiledsEntity msgFiled = new MdmModuleDbFiledsEntity();
    //    msgFiled.setChName("描述");
    //    msgFiled.setEnName("msg");
    //    msgFiled.setFiledLength("200");
    //    msgFiled.setFiledType("3");
    //    List<MdmModuleDbFiledsRuleEntity> msgRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity msgRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    msgRuleTitie.setFormName("optionRuleForm");
    //    msgRuleTitie.setRuleCode("title");
    //    msgRuleTitie.setRuleName("显示名");
    //    msgRuleTitie.setRuleType("2");
    //    msgRuleTitie.setRuleValue("描述");
    //    MdmModuleDbFiledsRuleEntity msgRulerow = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerow.setFormName("optionRuleForm");
    //    msgRulerow.setRuleCode("row");
    //    msgRulerow.setRuleName("宽度");
    //    msgRulerow.setRuleType("2");
    //    msgRulerow.setRuleValue("6");
    //    MdmModuleDbFiledsRuleEntity msgRuletype = new MdmModuleDbFiledsRuleEntity();
    //    msgRuletype.setFormName("optionRuleForm");
    //    msgRuletype.setRuleCode("type");
    //    msgRuletype.setRuleName("数据类型");
    //    msgRuletype.setRuleType("2");
    //    msgRuletype.setRuleValue("input");
    //    MdmModuleDbFiledsRuleEntity msgRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerequired.setFormName("optionRuleForm");
    //    msgRulerequired.setRuleCode("required");
    //    msgRulerequired.setRuleName("必填");
    //    msgRulerequired.setRuleType("2");
    //    msgRule.add(msgRulerequired);
    //    msgRule.add(msgRuletype);
    //    msgRule.add(msgRulerow);
    //    msgRule.add(msgRuleTitie);
    //    msgFiled.setMdmModuleDbFiledsRules(msgRule);
    //    mdmModuleDbFiledsEntityList.add(msgFiled);
    //    return mdmModuleDbFiledsEntityList;
    //}
    //
    ///**
    // * @param object
    // * @return com.hzya.frame.web.entity.JsonResultEntity
    // * @Author lvleigang
    // * @Description 查询数据（list 或者 分页）
    // * @Date 1:33 下午 2023/7/12
    // **/
    //@Override
    //public JsonResultEntity queryMdmOptionData(JSONObject object) {
    //    ModuleDto entity = getData("jsonStr", object, ModuleDto.class);
    //    //校验是否有servecr传参
    //    if (!checkStr(entity.getService())) {
    //        return BaseResult.getFailureMessageEntity("请先传递服务名");
    //    }
    //    if (!checkStr(entity.getValue())) {
    //        return BaseResult.getFailureMessageEntity("请先传递存储字段");
    //    }
    //    if (!checkStr(entity.getLabel())) {
    //        return BaseResult.getFailureMessageEntity("请先传递显示字段");
    //    }
    //    //查询数据源主表
    //    MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
    //    mdmModuleDbEntity.setId(entity.getId());
    //    mdmModuleDbEntity.setSts("Y");
    //    List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(mdmModuleDbEntity);
    //    if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    entity.setTableName(mdmModuleDbEntityList.get(0).getDbName());
    //    if (entity.getPageNum() != null && entity.getPageSize() != null) {
    //        PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
    //        List<HashMap<String, Object>> mapList = mdmModuleDao.queryTemplateData(entity);
    //        PageInfo pageInfo = new PageInfo(mapList);
    //        return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
    //    } else {
    //        List<HashMap<String, Object>> mapList = mdmModuleDao.queryTemplateData(entity);
    //        return BaseResult.getSuccessMessageEntity("查询数据成功", mapList);
    //    }
    //}
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情数据 区分类型 新增、修改、查看
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowDetailsData(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getId() == null || "".equals(entity.getId())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询模版

        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if (mdmModuleEntity == null ) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源主表
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        String tablename = null;
        JSONObject jsonObject = new JSONObject();
        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
            //查询数据
            Map<String, Object> queryData = new HashMap<>();
            queryData.put("tableName", mdmModuleDbEntityList.get(i).getDbName());//表名
            if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                queryData.put("detailFlag", false);//是否明细
                queryData.put("id", entity.getId());//字段
                HashMap<String, Object> datas = mdmModuleDbDao.getServiceDataById(queryData);
                jsonObject.put(mdmModuleDbEntityList.get(i).getDbName(), datas);
                tablename = mdmModuleDbEntityList.get(i).getDbName() + "_distribute";
            } else {
                queryData.put("detailFlag", true);//是否明细
                queryData.put("id", entity.getId());//字段
                List<HashMap<String, Object>> datas = mdmModuleDbDao.getServiceByFormmainId(queryData);
                jsonObject.put(mdmModuleDbEntityList.get(i).getDbName(), datas);
            }
        }
        if (tablename != null && !"".equals(tablename)) {
            Map<String, Object> queryData = new HashMap<>();
            queryData.put("tableName", tablename);//表名
            queryData.put("id", entity.getId());//字段
            List<HashMap<String, Object>> datas = mdmModuleDbDao.getServiceByDistributeId(queryData);
            jsonObject.put(tablename, datas);
        }


        return BaseResult.getSuccessMessageEntity("获取数据成功", jsonObject);
    }
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情数据修改
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity updateMdmShowDetailsData(JSONObject object) {
        JSONObject jsonObject = getstrObj("jsonStr", object);
        //校验是否有servecr传参
        if (!checkData(jsonObject, "mdmCode")) {
            return BaseResult.getFailureMessageEntity("请先传递服务名");
        }
        if (!checkData(jsonObject, "data")) {
            return BaseResult.getFailureMessageEntity("请先传递要修改的数据");
        }
        JSONObject saveData = jsonObject.getJSONObject("data");
        //校验唯一
        MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
        mdmModuleEntity.setMdmCode(jsonObject.getLong("mdmCode"));
        mdmModuleEntity.setSts("Y");
        List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
        if (mdmModuleEntities == null || mdmModuleEntities.size() != 1) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        mdmModuleEntity = mdmModuleEntities.get(0);
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        String res = checkDataOnly(jsonObject.getInteger("mdmCode"), saveData, true, mdmModuleEntity, mdmModuleDbEntityList);

        if (res == null || "".equals(res)) {
            return BaseResult.getSuccessMessageEntity("修改数据成功");
        } else {
            return BaseResult.getFailureMessageEntity(res);
        }
    }


    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情数据新增
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity saveMdmShowDetailsData(JSONObject object) {
        JSONObject jsonObject = getstrObj("jsonStr", object);
        //校验是否有servecr传参
        if (!checkData(jsonObject, "mdmCode")) {
            return BaseResult.getFailureMessageEntity("请先传递服务名");
        }
        if (!checkData(jsonObject, "data")) {
            return BaseResult.getFailureMessageEntity("请先传递要修改的数据");
        }
        JSONObject saveData = jsonObject.getJSONObject("data");
        //校验唯一
        MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
        mdmModuleEntity.setMdmCode(jsonObject.getLong("mdmCode"));
        mdmModuleEntity.setSts("Y");
        List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
        if (mdmModuleEntities == null || mdmModuleEntities.size() != 1) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        mdmModuleEntity = mdmModuleEntities.get(0);
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        String res = checkDataOnly(jsonObject.getInteger("mdmCode"), saveData, false, mdmModuleEntity, mdmModuleDbEntityList);

        if (res == null || "".equals(res)) {
            return BaseResult.getSuccessMessageEntity("保存数据成功");
        } else {
            return BaseResult.getFailureMessageEntity(res);
        }
    }
    //
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情数据修改
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity deleteMdmShowDetailsData(JSONObject object) {
        JSONObject jsonObject = getstrObj("jsonStr", object);
        //校验是否有servecr传参
        if (!checkData(jsonObject, "mdmCode")) {
            return BaseResult.getFailureMessageEntity("请先传递服务名");
        }
        if (!checkData(jsonObject, "id")) {
            return BaseResult.getFailureMessageEntity("请先传递要删除的数据");
        }
        //校验唯一
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(jsonObject.getLong("mdmCode"));
        if (mdmModuleEntity == null ) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
            if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {

                //查询视图，如果树形，删除下级及子集
                //查询展示类型
                MdmModuleViewEntity mdmModuleViewEntity = new MdmModuleViewEntity();
                mdmModuleViewEntity.setMdmId(mdmModuleEntity.getId());
                mdmModuleViewEntity.setSts("Y");
                List<MdmModuleViewEntity> moduleViewEntityList = mdmServiceCache.queryMdmModuleView(mdmModuleViewEntity);
                if (moduleViewEntityList == null || moduleViewEntityList.size() != 1) {
                    return BaseResult.getFailureMessageEntity("系统错误");
                }
                mdmModuleViewEntity = moduleViewEntityList.get(0);


                //删除自己
                FormmainDeleteDto formmainDeleteDto = new FormmainDeleteDto();
                formmainDeleteDto.setId(jsonObject.getString("id"));
                formmainDeleteDto.setLoginId(StpUtil.getLoginIdAsString());
                formmainDeleteDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                if (mdmModuleViewEntity != null && mdmModuleViewEntity.getViewName() != null && "1".equals(mdmModuleViewEntity.getViewName()) &&
                        mdmModuleViewEntity.getUpIdFiled() != null && !"".equals(mdmModuleViewEntity.getUpIdFiled())) {
                    formmainDeleteDto.setUpIdFiled(mdmModuleViewEntity.getUpIdFiled());

                    Map<String, Object> queryData = new HashMap<>();
                    queryData.put("tableName", mdmModuleDbEntityList.get(i).getDbName());//表名
                    queryData.put("detailFlag", false);//是否明细
                    queryData.put("id", jsonObject.getString("id"));//字段
                    HashMap<String, Object> datas = mdmModuleDbDao.getServiceDataById(queryData);
                    String upValue = null;
                    if (datas != null && datas.get(mdmModuleViewEntity.getUpIdFiled()) != null) {
                        upValue = datas.get(mdmModuleViewEntity.getUpIdFiled()).toString();
                    }
                    if (upValue != null) {
                        formmainDeleteDto.setUpIdFiledValue(upValue + "," + jsonObject.getString("id"));
                    } else {
                        formmainDeleteDto.setUpIdFiledValue(jsonObject.getString("id"));
                    }
                    mdmModuleDao.deleteChilder(formmainDeleteDto);
                }
                mdmModuleDao.deleteTemplateById(formmainDeleteDto);

            } else {
                //删除明细
                FormmainDeleteDto formmainDeleteDto = new FormmainDeleteDto();
                formmainDeleteDto.setFormmain_id(jsonObject.getString("id"));
                formmainDeleteDto.setLoginId(StpUtil.getLoginIdAsString());
                formmainDeleteDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                mdmModuleDao.deleteTemplateById(formmainDeleteDto);
            }
        }
        return BaseResult.getSuccessMessageEntity("删除数据成功");
    }
    //
    //
    ///**
    // * @param object
    // * @return com.hzya.frame.web.entity.JsonResultEntity
    // * @Author lvleigang
    // * @Description 处理分发数据
    // * @Date 9:40 上午 2023/10/18
    // **/
    //@Override
    //public JsonResultEntity doMdmDistribute(JSONObject object) {
    //    JSONObject jsonObject = getstrObj("jsonStr", object);
    //    //校验是否有servecr传参
    //    if (!checkData(jsonObject, "mdmCode")) {
    //        return BaseResult.getFailureMessageEntity("请先传递服务名");
    //    }
    //    if (!checkData(jsonObject, "id")) {
    //        return BaseResult.getFailureMessageEntity("请先传递要删除的数据");
    //    }
    //    if (!checkData(jsonObject, "appID")) {
    //        return BaseResult.getFailureMessageEntity("请先传递要删除的数据");
    //    }
    //    if (!checkData(jsonObject, "dataType")) {
    //        return BaseResult.getFailureMessageEntity("请先传递要删除的数据");
    //    }
    //    if("2".equals(jsonObject.getString("dataType"))){
    //        boolean flag = false;
    //        //1、根据服务名查询分发数据
    //        MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
    //        mdmModuleEntity.setMdmCode(jsonObject.getInteger("mdmCode"));
    //        mdmModuleEntity.setSts("Y");
    //        List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
    //        if (mdmModuleEntities != null && mdmModuleEntities.size() == 1) {
    //            MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
    //            mdmModuleDbEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //            mdmModuleDbEntity.setDbType("1");
    //            mdmModuleDbEntity.setSts("Y");
    //            List<MdmModuleDbEntity> mdmModuleDbEntities =  mdmModuleDbDao.queryBase(mdmModuleDbEntity);
    //            if (mdmModuleDbEntities != null && mdmModuleDbEntities.size() == 1) {
    //                mdmModuleDbEntity = mdmModuleDbEntities.get(0);
    //            }
    //            MdmModuleDistributeEntity mdmModuleDistributeEntity = new MdmModuleDistributeEntity();
    //            mdmModuleDistributeEntity.setAppId(jsonObject.getString("appID"));
    //            mdmModuleDistributeEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //            List<MdmModuleDistributeEntity> mdmModuleDistributeEntities = mdmModuleDistributeDao.queryBase(mdmModuleDistributeEntity);
    //            if (mdmModuleDistributeEntities != null && mdmModuleDistributeEntities.size() == 1) {
    //                if (mdmModuleDistributeEntities.get(0).getAddType() != null && "1".equals(mdmModuleDistributeEntities.get(0).getAddType())) {
    //                    //2、查找插件
    //                    if (mdmModuleDistributeEntities.get(0).getAddPlug() != null && !"".equals(mdmModuleDistributeEntities.get(0).getAddPlug())) {
    //                        //2、查找插件
    //                        SysApplicationPluginEntity sysApplicationPluginEntity = sysApplicationPluginDao.get(mdmModuleDistributeEntities.get(0).getAddPlug());
    //                        if(sysApplicationPluginEntity.getPluginCode() != null && !"".equals(sysApplicationPluginEntity.getPluginCode())){
    //                            //3、调用插件
    //                            PluginBaseEntity pluginBaseEntity = PluginUtils.getPluginsById(sysApplicationPluginEntity.getPluginCode());
    //                            try {
    //                                JsonResultEntity s = pluginBaseEntity.executeBusiness(jsonObject);
    //                                flag = true;
    //                            } catch (Exception e) {
    //                                logger.error("插件处理失败"+e.getMessage());
    //                            }
    //                        }
    //                    }
    //                } else {
    //                    //TODO 连线
    //                    flag = true;
    //                }
    //            }
    //            if(mdmModuleDbEntity.getDbName()!= null && !"".equals(mdmModuleDbEntity.getDbName())) {
    //                MdmDistributeEntity mdmDistributeEntity = new MdmDistributeEntity();
    //                mdmDistributeEntity.setCreate();
    //                mdmDistributeEntity.setTableName(mdmModuleDbEntity.getDbName()+"_distribute");
    //                mdmDistributeEntity.setFormmainId(jsonObject.getString("id"));
    //                mdmDistributeEntity.setAppId(jsonObject.getString("appID"));
    //                mdmDistributeEntity.setStatus("1");
    //                mdmDistributeEntity.setMsg("发送成功");
    //                if (!flag) {
    //                    mdmDistributeEntity.setStatus("3");
    //                    mdmDistributeEntity.setMsg("发送失败");
    //                }
    //                mdmModuleDao.saveDistribute(mdmDistributeEntity);
    //                return BaseResult.getSuccessMessageEntity("下发数据成功");
    //
    //            }else {
    //                return BaseResult.getFailureMessageEntity("系统错误");
    //            }
    //        }else {
    //            return BaseResult.getFailureMessageEntity("系统错误");
    //        }
    //    }else {
    //        if (!checkData(jsonObject, "distributeID")) {
    //            return BaseResult.getFailureMessageEntity("请先传递分发数据");
    //        }
    //        boolean flag = false;
    //        //1、根据服务名查询分发数据
    //        MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
    //        mdmModuleEntity.setMdmCode(jsonObject.getInteger("mdmCode"));
    //        mdmModuleEntity.setSts("Y");
    //        List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
    //        if (mdmModuleEntities != null && mdmModuleEntities.size() == 1) {
    //            MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
    //            mdmModuleDbEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //            mdmModuleDbEntity.setDbType("1");
    //            mdmModuleDbEntity.setSts("Y");
    //            List<MdmModuleDbEntity> mdmModuleDbEntities =  mdmModuleDbDao.queryBase(mdmModuleDbEntity);
    //            if (mdmModuleDbEntities != null && mdmModuleDbEntities.size() == 1) {
    //                mdmModuleDbEntity = mdmModuleDbEntities.get(0);
    //            }
    //            MdmModuleDistributeEntity mdmModuleDistributeEntity = new MdmModuleDistributeEntity();
    //            mdmModuleDistributeEntity.setAppId(jsonObject.getString("appID"));
    //            mdmModuleDistributeEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //            List<MdmModuleDistributeEntity> mdmModuleDistributeEntities = mdmModuleDistributeDao.queryBase(mdmModuleDistributeEntity);
    //            if (mdmModuleDistributeEntities != null && mdmModuleDistributeEntities.size() == 1) {
    //                if (mdmModuleDistributeEntities.get(0).getDeleteType() != null && "1".equals(mdmModuleDistributeEntities.get(0).getDeleteType())) {
    //                    //2、查找插件
    //                    if (mdmModuleDistributeEntities.get(0).getDeletePlug() != null && !"".equals(mdmModuleDistributeEntities.get(0).getDeletePlug())) {
    //                        //2、查找插件
    //                        SysApplicationPluginEntity sysApplicationPluginEntity = sysApplicationPluginDao.get(mdmModuleDistributeEntities.get(0).getDeletePlug());
    //                        if(sysApplicationPluginEntity.getPluginCode() != null && !"".equals(sysApplicationPluginEntity.getPluginCode())){
    //                            //3、调用插件
    //                            PluginBaseEntity pluginBaseEntity = PluginUtils.getPluginsById(sysApplicationPluginEntity.getPluginCode());
    //                            try {
    //                                JsonResultEntity s = pluginBaseEntity.executeBusiness(jsonObject);
    //                                flag = true;
    //                            } catch (Exception e) {
    //                                logger.error("插件处理失败"+e.getMessage());
    //                            }
    //                        }
    //                    }
    //                } else {
    //                    //TODO 连线
    //                    flag = true;
    //                }
    //            }
    //            if(mdmModuleDbEntity.getDbName()!= null && !"".equals(mdmModuleDbEntity.getDbName())) {
    //                //删除数据
    //                MdmDistributeEntity mdmDistributeEntity = new MdmDistributeEntity();
    //                mdmDistributeEntity.setId(jsonObject.getString("distributeID"));
    //                mdmDistributeEntity.setTableName(mdmModuleDbEntity.getDbName()+"_distribute");
    //                mdmDistributeEntity.setFormmainId(jsonObject.getString("id"));
    //                mdmDistributeEntity.setAppId(jsonObject.getString("appID"));
    //                mdmDistributeEntity.setStatus("1");
    //                mdmDistributeEntity.setMsg("删除成功");
    //                if (!flag) {
    //                    mdmDistributeEntity.setStatus("3");
    //                    mdmDistributeEntity.setMsg("删除失败");
    //                }
    //                mdmModuleDao.updateDistribute(mdmDistributeEntity);
    //                return BaseResult.getSuccessMessageEntity("删除数据成功");
    //
    //            }else {
    //                return BaseResult.getFailureMessageEntity("系统错误");
    //            }
    //        }else {
    //            return BaseResult.getFailureMessageEntity("系统错误");
    //        }
    //    }
    //
    //}
    //
    /**
     * @param mdmCode
     * @param saveData
     * @param mdmModuleEntity
     * @param mdmModuleDbEntityList
     * @param flag                  修改 新增
     * @return java.lang.String
     * @Author lvleigang
     * @Description 校验数据
     * @Date 11:20 上午 2023/11/6
     **/
    private String checkDataOnly(Integer mdmCode, JSONObject saveData, boolean flag, MdmModuleEntity mdmModuleEntity, List<MdmModuleDbEntity> mdmModuleDbEntityList) {
        StringBuffer str = new StringBuffer();

        //查询字段
        //查询字段下的必填规则
        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
        mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbFiledsEntity.setSts("Y");
        mdmModuleDbFiledsEntity.setRoletype("required");
        mdmModuleDbFiledsEntity.setRoleValue("true");
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmModuleDbFiledsDao.queryBase(mdmModuleDbFiledsEntity);

        if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    JSONObject jsonObject = saveData.getJSONObject(mdmModuleDbEntityList.get(i).getDbName());
                    for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                        if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i).getId())) {
                            if (jsonObject.get(mdmModuleDbFiledsEntityList.get(i1).getEnName()) == null || "".equals(jsonObject.getString(mdmModuleDbFiledsEntityList.get(i1).getEnName()))) {
                                if (str.toString() != null && !"".equals(str.toString())) {
                                    str.append("；");
                                }
                                str.append(mdmModuleDbEntityList.get(i).getRemark() + "的" + mdmModuleDbFiledsEntityList.get(i1).getChName() + "不为空");
                            }
                        }
                    }
                } else {
                    JSONArray jsonArray = saveData.getJSONArray(mdmModuleDbEntityList.get(i).getDbName());
                    if (jsonArray != null && jsonArray.size() > 0) {
                        for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                            if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i).getId())) {
                                for (int i2 = 0; i2 < jsonArray.size(); i2++) {
                                    JSONObject jsonObject = jsonArray.getJSONObject(i2);
                                    if (jsonObject.get(mdmModuleDbFiledsEntityList.get(i1).getEnName()) == null || "".equals(jsonObject.getString(mdmModuleDbFiledsEntityList.get(i1).getEnName()))) {
                                        if (str.toString() != null && !"".equals(str.toString())) {
                                            str.append("；");
                                        }
                                        str.append(mdmModuleDbEntityList.get(i).getRemark() + "的" + mdmModuleDbFiledsEntityList.get(i1).getChName() + "不为空");
                                        break;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        if (str == null || "".equals(str.toString())) {
            //校验数据
            MdmModuleDbFiledsEntity onlyFiledsEntity = new MdmModuleDbFiledsEntity();
            onlyFiledsEntity.setMdmId(mdmModuleEntity.getId());
            onlyFiledsEntity.setSts("Y");
            onlyFiledsEntity.setRoletype("fieldsSole");
            onlyFiledsEntity.setRoleValue("true");

            List<MdmModuleDbFiledsEntity> onlyEntityList = mdmModuleDbFiledsDao.queryBase(onlyFiledsEntity);

            if (onlyEntityList != null && onlyEntityList.size() > 0) {
                for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                    if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                        JSONObject jsonObject = saveData.getJSONObject(mdmModuleDbEntityList.get(i).getDbName());
                        for (int i1 = 0; i1 < onlyEntityList.size(); i1++) {
                            if (onlyEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i).getId())) {
                                //校验唯一
                                Map<String, String> map = new HashMap<>();
                                map.put("tableName", mdmModuleDbEntityList.get(i).getDbName());
                                if (flag) {
                                    map.put("id", jsonObject.getString("id"));
                                }
                                map.put("filedName", onlyEntityList.get(i1).getEnName());
                                map.put("filedValue", jsonObject.getString(onlyEntityList.get(i1).getEnName()));
                                Integer count = mdmModuleDao.checkData(map);
                                if (count > 0) {
                                    if (str.toString() != null && !"".equals(str.toString())) {
                                        str.append("；");
                                    }
                                    str.append(mdmModuleDbEntityList.get(i).getRemark() + "的" + mdmModuleDbFiledsEntityList.get(i1).getChName() + "已存在");
                                }
                            }
                        }
                    } else {
                        JSONArray jsonArray = saveData.getJSONArray(mdmModuleDbEntityList.get(i).getDbName());
                        if (jsonArray != null && jsonArray.size() > 0) {
                            for (int i1 = 0; i1 < onlyEntityList.size(); i1++) {
                                if (onlyEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i).getId())) {
                                    for (int i2 = 0; i2 < jsonArray.size(); i2++) {
                                        JSONObject jsonObject = jsonArray.getJSONObject(i2);

                                        //校验唯一
                                        Map<String, String> map = new HashMap<>();
                                        map.put("tableName", mdmModuleDbEntityList.get(i).getDbName());
                                        if (flag) {
                                            map.put("id", jsonObject.getString("id"));
                                        }
                                        map.put("filedName", onlyEntityList.get(i1).getEnName());
                                        map.put("filedValue", jsonObject.getString(onlyEntityList.get(i1).getEnName()));
                                        Integer count = mdmModuleDao.checkData(map);
                                        if (count > 0) {
                                            if (str.toString() != null && !"".equals(str.toString())) {
                                                str.append("；");
                                            }
                                            str.append(mdmModuleDbEntityList.get(i).getRemark() + "的" + mdmModuleDbFiledsEntityList.get(i1).getChName() + "已存在");
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }


        //保存数据
        if (str == null || "".equals(str.toString())) {
            String id = UUIDUtils.getUUID();
            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    JSONObject jsonObject = saveData.getJSONObject(mdmModuleDbEntityList.get(i).getDbName());
                    //保存数据
                    MdmDataDto mdmDataDto = new MdmDataDto();
                    mdmDataDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                    MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity1 = new MdmModuleDbFiledsEntity();
                    mdmModuleDbFiledsEntity1.setMdmId(mdmModuleEntity.getId());
                    mdmModuleDbFiledsEntity1.setDbId(mdmModuleDbEntityList.get(i).getId());
                    mdmModuleDbFiledsEntity1.setSts("Y");
                    List<MdmModuleDbFiledsEntity> fileds = mdmModuleDbFiledsDao.queryBase(mdmModuleDbFiledsEntity1);
                    //查询单据规则
                    MdmTableCodeRuleEntity mdmTableCodeRuleEntity = new MdmTableCodeRuleEntity();
                    mdmTableCodeRuleEntity.setMdmId(mdmModuleEntity.getId());
                    mdmTableCodeRuleEntity.setDbId(mdmModuleDbEntityList.get(i).getId());
                    mdmTableCodeRuleEntity.setSts("Y");
                    List<MdmTableCodeRuleEntity> allMdmTableCodeRuleEntities = mdmServiceCache.queryMdmTableCodeRuleEntity(mdmTableCodeRuleEntity);
                    List<MdmTableCodeRuleEntity> mdmTableCodeRuleEntities = new ArrayList<>();
                    if(allMdmTableCodeRuleEntities != null && allMdmTableCodeRuleEntities.size() > 0){
                        for (int i1 = 0; i1 < allMdmTableCodeRuleEntities.size(); i1++) {
                            if(mdmModuleDbEntityList.get(i).getId().equals(allMdmTableCodeRuleEntities.get(i1).getDbId())){
                                mdmTableCodeRuleEntities.add(allMdmTableCodeRuleEntities.get(i1));
                            }
                        }
                    }
                    StringBuffer document_rule = new StringBuffer();
                    Integer document_rule_num = 0;
                    if (mdmTableCodeRuleEntities != null && mdmTableCodeRuleEntities.size() > 0) {
                        for (int i1 = 0; i1 < mdmTableCodeRuleEntities.size(); i1++) {
                            //1、连接符号 2、字符串 3、日期 4、流水号
                            if ("1".equals(mdmTableCodeRuleEntities.get(i1).getDbType())) {
                                document_rule.append("-");
                            } else if ("2".equals(mdmTableCodeRuleEntities.get(i1).getDbType())) {
                                document_rule.append(mdmTableCodeRuleEntities.get(i1).getDbValue());
                            } else if ("3".equals(mdmTableCodeRuleEntities.get(i1).getDbType())) {
                                SimpleDateFormat sdf = new SimpleDateFormat(mdmTableCodeRuleEntities.get(i1).getDbValue());//要转换的时间格式
                                String stra = sdf.format(new Date());
                                document_rule.append(stra);
                            } else if ("4".equals(mdmTableCodeRuleEntities.get(i1).getDbType())) {
                                document_rule_num = mdmTableCodeRuleEntities.get(i1).getDbValue().length();
                            }
                        }
                    }
                    List<MdmDataFiledDto> mdmDataFiledDtos = new ArrayList<>();
                    for (int i1 = 0; i1 < fileds.size(); i1++) {
                        if (jsonObject.get(fileds.get(i1).getEnName()) != null) {
                            MdmDataFiledDto mdmDataFiledDto = new MdmDataFiledDto();
                            mdmDataFiledDto.setFiledsName(fileds.get(i1).getEnName());
                            mdmDataFiledDto.setFiledsValue(jsonObject.getString(fileds.get(i1).getEnName()));
                            mdmDataFiledDtos.add(mdmDataFiledDto);
                        }
                    }
                    MdmDataFiledDto mdmDataFiledDto = new MdmDataFiledDto();
                    mdmDataFiledDto.setFiledsName("logid");
                    mdmDataFiledDto.setFiledsValue(StpUtil.getLoginIdAsString());
                    mdmDataFiledDtos.add(mdmDataFiledDto);
                    mdmDataDto.setMdmDataFiledDtos(mdmDataFiledDtos);
                    if (flag) {
                        mdmDataDto.setId(jsonObject.getString("id"));
                        id = jsonObject.getString("id");
                        int a = mdmModuleDao.updateForm(mdmDataDto);
                    } else {

                        mdmDataDto.setDbType(mdmModuleDbEntityList.get(i).getDbType());
                        mdmDataDto.setDocumentRule(document_rule.toString());
                        mdmDataDto.setDocumentRuleNum(document_rule_num);
                        MdmDataFiledDto ids = new MdmDataFiledDto();
                        ids.setFiledsName("id");
                        ids.setFiledsValue(id);
                        mdmDataFiledDtos.add(ids);
                        mdmDataDto.setMdmDataFiledDtos(mdmDataFiledDtos);
                        int a = mdmModuleDao.saveForm(mdmDataDto);
                    }
                }
            }

            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                if ("2".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    //删除明细
                    FormmainDeleteDto formmainDeleteDto = new FormmainDeleteDto();
                    formmainDeleteDto.setFormmain_id(id);
                    formmainDeleteDto.setLoginId(StpUtil.getLoginIdAsString());
                    formmainDeleteDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                    mdmModuleDao.deleteTemplateById(formmainDeleteDto);

                    JSONArray jsonArray = saveData.getJSONArray(mdmModuleDbEntityList.get(i).getDbName());
                    if (jsonArray != null && jsonArray.size() > 0) {
                        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity1 = new MdmModuleDbFiledsEntity();
                        mdmModuleDbFiledsEntity1.setMdmId(mdmModuleEntity.getId());
                        mdmModuleDbFiledsEntity1.setSts("Y");
                        List<MdmModuleDbFiledsEntity> allfileds = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity1);
                        List<MdmModuleDbFiledsEntity> fileds = new ArrayList<>();
                        if(allfileds != null && allfileds.size() > 0){
                            for (int i1 = 0; i1 < allfileds.size(); i1++) {
                                if(mdmModuleDbEntityList.get(i).getId().equals(allfileds.get(i1).getDbId())){
                                    fileds.add(allfileds.get(i1));
                                }
                            }
                        }

                        for (int i2 = 0; i2 < jsonArray.size(); i2++) {
                            JSONObject jsonObject = jsonArray.getJSONObject(i2);
                            //保存数据
                            MdmDataDto mdmDataDto = new MdmDataDto();
                            mdmDataDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                            List<MdmDataFiledDto> mdmDataFiledDtos = new ArrayList<>();
                            for (int i1 = 0; i1 < fileds.size(); i1++) {
                                MdmDataFiledDto mdmDataFiledDto = new MdmDataFiledDto();
                                mdmDataFiledDto.setFiledsName(fileds.get(i1).getEnName());
                                mdmDataFiledDto.setFiledsValue(jsonObject.getString(fileds.get(i1).getEnName()));
                                mdmDataFiledDtos.add(mdmDataFiledDto);
                            }
                            MdmDataFiledDto mdmDataFiledDto = new MdmDataFiledDto();
                            mdmDataFiledDto.setFiledsName("logid");
                            mdmDataFiledDto.setFiledsValue(StpUtil.getLoginIdAsString());
                            mdmDataFiledDtos.add(mdmDataFiledDto);

                            MdmDataFiledDto formain_id = new MdmDataFiledDto();
                            formain_id.setFiledsName("formmain_id");
                            formain_id.setFiledsValue(id);
                            mdmDataFiledDtos.add(formain_id);

                            mdmDataDto.setMdmDataFiledDtos(mdmDataFiledDtos);
                            if (jsonObject.getString("id") != null) {
                                MdmDataFiledDto sts = new MdmDataFiledDto();
                                sts.setFiledsName("sts");
                                sts.setFiledsValue("Y");
                                mdmDataFiledDtos.add(sts);
                                mdmDataDto.setId(jsonObject.getString("id"));
                                int a = mdmModuleDao.updateForm(mdmDataDto);
                            } else {
                                MdmDataFiledDto ids = new MdmDataFiledDto();
                                ids.setFiledsName("id");
                                ids.setFiledsValue(UUIDUtils.getUUID());
                                mdmDataFiledDtos.add(ids);
                                mdmDataDto.setMdmDataFiledDtos(mdmDataFiledDtos);
                                mdmDataDto.setDbType(mdmModuleDbEntityList.get(i).getDbType());
                                int a = mdmModuleDao.saveForm(mdmDataDto);
                            }
                        }
                    }
                }
            }
        }
        return str.toString();
    }


    /**
     * @param jsonObject
     * @return boolean
     * @Author lvleigang
     * @Description 校验是否有值
     * @Date 2:20 下午 2023/7/10
     **/
    private boolean checkData(JSONObject jsonObject, String key) {
        if (jsonObject != null
                && jsonObject.getString(key) != null
                && !"".equals(jsonObject.getString(key))) {
            return true;
        }
        return false;
    }

    protected <T> T getData(String key, JSONObject jsonObject, Class<T> clz) {
        if (checkStr(jsonObject.getString(key))) {
            return jsonObject.getJSONObject(key).toJavaObject(clz);
        }
        return null;
    }

    /**
     * @param key
     * @param object
     * @return com.alibaba.fastjson.JSONObject
     * @Author lvleigang
     * @Description 获取对象转换成jsonobj
     * @Date 11:51 下午 2023/7/10
     **/
    protected JSONObject getstrObj(String key, JSONObject object) {
        if (checkStr(object.getString(key))) {
            return object.getJSONObject(key);
        }
        return new JSONObject();
    }

    /**
     * @param str
     * @return void
     * @Author lvleigang
     * @Description 校验字符串
     * @Date 11:41 上午 2022/12/7
     **/
    protected Boolean checkStr(String str) {
        Boolean flag = true;
        if (str == null || "".equals(str)) {
            flag = false;
        }
        return flag;
    }

    /**
     * @param str
     * @return void
     * @Author lvleigang
     * @Description 校验字符串
     * @Date 11:41 上午 2022/12/7
     **/
    protected Boolean checkInt(Integer str) {
        Boolean flag = true;
        if (str == null) {
            flag = false;
        }
        return flag;
    }
}
